#include <stdio.h>
#include <time.h>

#define bool  unsigned char

int  main(void)
{
    long int unten, oben,
             i, j, k, teiler;
    bool  prim, goldbach;
    clock_t start, ende;

    printf("Ueberpruefung der Goldbach-Vermutung\n");
    printf("====================================\n\n");
    printf("Dieses Programm ueberprueft fuer einen anzugebenden Bereich\n");
    printf("die Goldbach-Vermutung, die lautet:\n");
    printf("    Jede gerade Zahl groesser als 2 laesst sich als\n");
    printf("    Summe von zwei Primzahlen darstellen\n\n");
    
    printf("Untere Bereichgrenze ? ");
    scanf("%ld", &unten);
    if (unten%2 != 0)
       unten++;
    printf("Obere Bereichgrenze ? ");
    scanf("%ld", &oben);
    if (oben%2 != 0)
       oben--;

    start = clock();

       /* Ueberpruefen der Goldbachvermutung fuer den Bereich */
    goldbach=1;
    for (i=unten ; i<=oben && goldbach; i=i+2) {
        for (j=2 ; j<i ; j++) {
           prim=1;
           for (teiler=2 ; teiler<j/2 ; teiler++)
              if (j%teiler==0) {
                 prim=0;
                 break;
              }
           if (prim) {
              k=i-j;
              for (teiler=2 ; teiler<k/2 && prim ; teiler++)
                 if (k%teiler==0) {
                    prim=0;
                    break;
                 }
              if ((goldbach=prim) == 1)
                 break;
           }
        }
    }
    if (goldbach)
       printf("\nFuer Bereich [%ld,%ld] stimmt Goldbach-Vermutung\n",
              unten, oben);
    else
       printf("\n\aVerstoss gegen Goldbach-Vermutung bei Zahl %ld\n", i-2);

   ende = clock();

   printf("\n\nGebrauchte CPU-Zeit fuer dieses Programm: %6.3f Sek.\n",
          (ende-start)/(double)CLOCKS_PER_SEC);
   /* Auf manchen Nicht-ANSI C-Compilern anstelle der vorherigen Zeile
          (ende-start)/CLK_TCK);
      angeben
    */
   return(0);
}
