#include <stdio.h>
#include <ctype.h>
#include <time.h>

#define setze_ziffer(ziff)    ziffer |= 1<<ziff
#define loesche_ziffer(ziff)  ziffer ^= 1<<ziff
#define ist_ziffer_besetzt(ziff) ((ziffer>>ziff)&1)

int  main(void)
{
    int  ziffer=0,  /* einzelnen Bitpositionen zeigen an, ob Ziffer */
                    /* bereits benutzt wurde oder nicht             */
         zahl,  /* Eingegebene Zahl */
         zahl1, zahl2, zahl3, /* gefundene Loesungen */
         e3, e2, e1,   /* Ziffern fuer die 1.Zahl */
         z3, z2, z1,   /* Ziffern fuer die 2.Zahl */
         d3, d2, d1,   /* Ziffern fuer die 3.Zahl */
         ziffer3,  /* hintere Ziffer der eingegebenen Zahl  */
         ziffer2,  /* mittlere Ziffer der eingegebenen Zahl */
         vorne,    /* vordere (beiden) Ziffer der eingegebenen Zahl */
         eins, zwei, drei, /* Positionssummen */
         uebertrag1, uebertrag2,   /* enthaelt einen evtl. Uebertrag */
         lsg=0, /* zaehlt die Loesungen mit */
         lsg_gefunden=0,  /* boole'sche Var: zeigt an, ob Loesung gefunden */
         alle; /* boole'sche Var: ob alle oder nur eine Loesung ausgegeben */
    clock_t start, ende;

    printf("Zahlen zu einer Summe ermitteln\n");
    printf("===============================\n\n");
    printf("Dieses Programm ermittelt zu einer vorgegebenen Zahl\n");
    printf("3 Zahlen abc, def und ghi, deren Summe gleich dieser Zahl ist:\n");
    printf("     abc\n");
    printf("     def\n");
    printf("     ghi\n");
    printf("   -----\n");
    printf("    zahl\n");
    printf("Die einzelnen Ziffern der 3 Zahlen sind dabei alle verschieden.\n");
    printf("\n\n");

    printf("Gib eine drei- oder vierstellige Zahl ein: ");
    scanf("%d", &zahl); getchar();

    while (zahl<100 || zahl>9999) {
       printf("   ...... Zahl muss drei- oder vierstellig sein.\n");
       printf("Wiederhole deine Eingabe: ");
       scanf("%d", &zahl);  getchar();
    }

    printf("\nAlle Loesungen anzeigen (j/n) ? ");
    alle=toupper(getchar())=='J';

    start=clock();

     vorne=zahl/100;
     ziffer2=zahl%100/10;
     ziffer3=zahl%10;

     for (e3=0 ; e3<=9 ; e3++) {
        setze_ziffer(e3);
        for (z3=0 ; z3<=9 ; z3++) {
           if (ist_ziffer_besetzt(z3)) continue; /*-- Naechstes z3*/
           setze_ziffer(z3);
           for (d3=0 ; d3<=9 ; d3++) {
              if (ist_ziffer_besetzt(d3)) continue; /*-- Naechstes d3*/
              drei=e3+z3+d3;
              if (drei%10!=ziffer3) continue; /*-- Naechstes d3*/
              setze_ziffer(d3);
              uebertrag1=drei/10;
              for (e2=0 ; e2<=9 ; e2++) {
                 if (ist_ziffer_besetzt(e2)) continue; /*-- Naechstes e2*/
                 setze_ziffer(e2);
                 for (z2=0 ; z2<=9 ; z2++) {
                    if (ist_ziffer_besetzt(z2)) continue; /*-- Naechstes z2*/
                    setze_ziffer(z2);
                    for (d2=0 ; d2<=9 ; d2++) {
                       if (ist_ziffer_besetzt(d2)) continue; /*-- Naechstes d2*/
                       zwei=e2+z2+d2+uebertrag1;
                       if (zwei%10!=ziffer2) continue; /*-- Naechstes d2*/
                       setze_ziffer(d2);
                       uebertrag2=zwei/10;
                       for (e1=0 ; e1<=9 ; e1++) {
                          if (ist_ziffer_besetzt(e1)) continue; /*-- Naechstes e1*/
                          setze_ziffer(e1);
                          for (z1=0 ; z1<=9 ; z1++) {
                             if (ist_ziffer_besetzt(z1)) continue; /*-- Naechstes z1*/
                             setze_ziffer(z1);
                             for (d1=0 ; d1<=9 ; d1++) {
                                if (ist_ziffer_besetzt(d1)) continue; /*-- Naechstes d1*/
                                eins=e1+z1+d1+uebertrag2;
                                if (eins==vorne) {
                                   zahl1 = e1*100+e2*10+e3;
                                   zahl2 = z1*100+z2*10+z3;
                                   zahl3 = d1*100+d2*10+d3;
                                   if (zahl1+zahl2+zahl3==zahl) {
                                      ++lsg;
                                      if (alle || (!alle && !lsg_gefunden)) {
                                         printf("\n%5d. Loesung:", lsg);
                                         printf("%5d\n", zahl1);
                                         printf("%20d\n", zahl2);
                                         printf("%20d\n", zahl3);
                                         printf("               -----\n");
                                         printf("%20d\n", zahl);
                                         lsg_gefunden=1;
                                      }
                                   }
                                }
                             }
                             loesche_ziffer(z1);
                          } /*___z1___*/
                         loesche_ziffer(e1);
                      } /*___e1___*/
                      loesche_ziffer(d2);
                   } /*___d2___*/
                   loesche_ziffer(z2);
                } /*___z2___*/
                loesche_ziffer(e2);
             } /*___e2___*/
             loesche_ziffer(d3);
          } /*___d3___*/
          loesche_ziffer(z3);
       } /*___z3___*/
       loesche_ziffer(e3);
     } /*___e3___*/

     if (lsg_gefunden) {
        printf("\n\n----> Insgesamt %d Loesungen gefunden\n", lsg);
     } else {
        printf("\n   Zu dieser Zahl gibt es keine Loesung!\n");
     }

   ende=clock();
   printf("\n\nGebrauchte CPU-Zeit fuer dieses Programm: %6.3f Sek.\n",
          (ende-start)/(double)CLOCKS_PER_SEC);
   return(0);
}
