#include <graphics.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>

#define G         9.81 
#define PI        3.14159
#define EPSILON   0.0001

#define KORB_MALEN                               \
       setcolor( BLACK );                        \
       setlinestyle( SOLID_LINE, 3 );            \
       ellipse( zielx, ziely, 0, 360, 20, 10);   \
       line( zielx+20, ziely, zielx+20, maxy-9); \
       setlinestyle( SOLID_LINE, 1 );            \
       polygon[0] = zielx-20;                    \
       polygon[1] = ziely;                       \
       polygon[2] = zielx-10;                    \
       polygon[3] = ziely+30;                    \
       polygon[4] = zielx+10;                    \
       polygon[5] = ziely+30;                    \
       polygon[6] = zielx+20;                    \
       polygon[7] = ziely;                       \
       polygon[8] = zielx+10;                    \
       polygon[9] = ziely-5;                     \
       polygon[10] = zielx;                      \
       polygon[11] = ziely-10;                   \
       polygon[12] = zielx-10;                   \
       polygon[13] = ziely-5;                    \
       polygon[14] = zielx-20;                   \
       polygon[15] = ziely;                      \
       setfillstyle( CROSSDIAG_FILL, BLACK );    \
       fillpoly( 6, polygon );

int  main( int argc, char *argv[] )
{
   int  i, x, y,
        maxx, maxy, mittex, mittey,
        startx, starty, zielx, ziely,
        getroffen=0;
   float winkel,
         t, v, xv, yv;
   int  polygon[6];
   void *puffer1,
        *puffer2;

    srand(time(NULL)); /* Zufallszahlen-Generator initialisieren */

    /*------- Graphik einschalten und entsprechende Var. initialisieren -----*/
    initgraph( 640, 480 );
    maxx   = getmaxx();
    maxy   = getmaxy();
    mittex = maxx/2;
    mittey = maxy/2;
    startx = 50;
    starty = maxy-21;

    /*------- Programm-Erklaerung ausgeben ---------------------------------*/
    outtextxy( 10, 10, maxx, maxy, 
             "Basketballspiel\n"
             "===============\n\n"
             "Dieses Programm simuliert das Werfen eines Basketballs.\n"
             "Sie muessen dazu immer den Abwurfwinkel und die\n"
             "Anfangsgeschwindigkeit (in m/s) des Balles eingeben.\n\n\n"
             "Weiter mit einer beliebiger Taste........");
    getch();

    /*------- Basketball malen und Bild im Puffer sichern -------------------*/
    cleardevice( LIGHTBLUE );
    setfillstyle( DENSE1_FILL, RED );
    fillellipse( startx, starty, 5, 5 );
    getimage( startx-5, starty-5, startx+5, starty+5, &puffer1 );

    /*------- Position des Korbes zufaellig bestimmen -----------------------*/
    zielx = mittex+rand()%(mittex-20);
    ziely = 100+rand()%mittey;
    do {
       if (getroffen) {
          /*------- Position des Korbes zufaellig bestimmen ----------------*/
          zielx = mittex+rand()%(mittex-20);
          ziely = 100+rand()%mittey;
       }
       cleardevice( LIGHTBLUE );
       getimage( 295, 295, 305, 305, &puffer2 );
       /*------- Korb und Boden malen --------------------------------------*/
       KORB_MALEN;
       setlinestyle( SOLID_LINE, 3 );
       line( 0, maxy-9, maxx, maxy-9 );

       /*------- Ball huepfen lassen, bis mit der Eingabe begonnen wird ----*/
       while (!kbhit()) {
          for (i=60 ; i>=-60 ; i--) {
             putimage( 45, starty-1-abs(i), puffer1, COPY_PUT );
             delay( 1 );
             putimage( 45, starty-1-abs(i), puffer2, COPY_PUT );
             if ( kbhit() )
                break;
          }
       }

       /*------- Ball anhalten ---------------------------------------------*/
       startx = 50;
       starty = maxy-21;
       putimage( startx-5, starty, puffer1, COPY_PUT );

       /*------- Abwurfwinkel einlesen ------------------------------------*/
       winkel = getdouble( "Abwurfwinkel: " );
       outtextxy( 150, 20, maxx, maxy, "Abwurfwinkel: %.2f", winkel);

       /*------- Anfangsgeschwindigkeit einlesen ---------------------------*/
       v = getdouble( "Anfangs-Geschwindigkeit (in m/s): " );
       outtextxy( 150, 40, maxx, maxy, "Anfangs-Geschwindigkeit (in m/s): %.2f", v );

       /*------- x- und y-Geschwindigkeit berechnen ------------------------*/
       winkel = winkel/180*PI;
       xv = cos(winkel)*v;
       yv = sin(winkel)*v;

       /*------- Ball fliegen lassen ---------------------------------------*/
       getroffen = 0;
       t=0;
       x = startx;
       y = starty;
       while (1) {
          delay(10);
          if (x>0 && x<=maxx && y>=5 && y<=starty)
             putimage( x-5, y, puffer2, COPY_PUT );
          x = (int)(startx+xv*t);
          y = (int)(starty+ (-yv*t +0.5*G*t*t));
          if ( y>starty ) {
             t = 0;
             startx = x;
             xv = xv/2;
             yv = yv/2;
          }
          if (x>0 && x<=maxx && y>=5 && y<=starty || (xv<EPSILON && yv<EPSILON))
             putimage( x-5, y, puffer1, COPY_PUT );
          KORB_MALEN;
          /*-------- Pruefen, ob getroffen ---------------------------------*/
          if ( abs(zielx-x)<=12 && abs(ziely-y)<=5 ) {
             delay(100);
             xv = 0;
             startx = x;
             setcolor( BLACK );
             outtextxy( 50, 150, maxx, maxy, "Getroffen" );
             getroffen = 1;
          }
          /*-------- Pruefen, ob Ball zur Ruhe gekommen; dann break ---------*/
          if ( (xv<EPSILON && yv<EPSILON) || x>=maxx ) {
             if (!getroffen) {
                setcolor( BLACK );
                outtextxy( 50, 150, maxx, maxy, "Das war daneben" );
             }
             break;
          }
          t += 0.05;
       }
       outtextxy( 50, 200, maxx, maxy, "Noch einmal (j/n) ");
    } while ( getch() != Key_N );
    closegraph();
    return 0;
}
