#include <graphics.h>
#include <ctype.h>
#include <time.h>
#include <stdlib.h>
#include <math.h>

int  main( int argc, char *argv[] )
{
   int i, farbe,
       t, n, m, p,
       maxy, mittex, mittey,
       startx, starty;
   double s, laenge=1, x, y;
   const double pi=4*atan(1);
   char loeschen, ausfuellen, farbig;
   char string[1000];
   int  polygon[ 100000 ];

   /*---- Graphik initialisieren -------------------------------------------*/
   initgraph( 640, 480 );
   maxy   = getmaxy();
   mittex = getmaxx()/2;
   mittey = maxy/2;

   /*---- Programmerklaerung ausgeben --------------------------------------*/
   sprintf( string,
            "Die Kochsche Schneeflocke\n"
            "=========================\n\n"
            "Die Kochsche Schneflocke wird nach folgenden Regeln konstruiert:\n"
            "Zunchst nimmt man ein Dreieck mit Lnge 1 fuer alle Seiten.\n"
            "Nun fgt man in der Mitte einer jeden Seite ein neues Dreieck\n"
            "hinzu, das in der Form identisch ist, aber nur ein Drittel so gross.\n"
            "Man erhlt dann einen Davidstern mit 12 Seiten. Nun fgt man\n"
            "in der Mitte jeder dieser 12 Seiten wieder ein Dreieck hinzu,\n"
            "dessen Grsse wieder auf ein Drittel reduziert ist.\n"
            "Diesen Vorgang wiederholt man, bis keine Verkleinerung mehr\n"
            "mglich ist.\n\n"
            "Dieses Programm fhrt diese Iteration durch. Mit jedem Tastendruck\n"
            "werden neue auf ein Drittel reduzierte Dreiecke hinzugefgt.\n\n");
   outtextxy( 10, 10, getmaxx(), getmaxy(), string );
   getch();
   cleardevice( WHITE );
   farbig = getcharacter( "Farben verwenden (j/n) ? " );
   loeschen = getcharacter( "Soll das vorherige Dreieck immer gelscht werden (j/n) ? " );
   ausfuellen = getcharacter( "Soll Dreieck ausgefllt werden (j/n) ? " );

   /*---- Zufallszahlen-Generator initialisieren ---------------------------*/
   srand( time(NULL) );

   /*---- Groesste y-Pixelzahl bestimmen, die nur 3er-Primfaktoren hat -----*/
   while ( laenge*4/3 <= maxy )
       laenge *= 3;
   laenge /= 3;

   /*---- Startpostion fuer das Zeichnen ermitteln -------------------------*/
   startx = (int)(mittex-laenge/2);
   starty = (int)(mittey+laenge/4);

   /*---- Kochsche Schneeflocke mit immer feinerer Granularitaet zeichnen --*/
   t = 0;
   while ( laenge >= 1 ) {
      farbe = ( tolower(farbig)=='j') ? rand()%getmaxcolor() : BLACK;
      setcolor( farbe );
      p = 0;
      x = startx;
      polygon[p++] = (int)x;
      y = starty;
      polygon[p++] = (int)y;
      for ( i=0 ; i<3 ; i++ ) {
         for ( n=0 ; n<=pow(4,t)-1 ; n++ ) {
            m = n;
            s = 0;
            while ( m>0 ) {
               switch ( m%4 ) {
                  case 1: s += 1.0/3; break;
                  case 2: s -= 1.0/3; break;
               }
               m /= 4;
            }
            x = x+cos(i*(-2.0*pi/3)+pi*s)*laenge;
            polygon[p++] = (int)x;
            y = y+sin(i*(-2.0*pi/3)+pi*s)*laenge;
            polygon[p++] = (int)y;
         }
      }
      if ( tolower(ausfuellen) == 'j' ) {
         setfillstyle( SOLID_FILL, farbe );
         fillpoly( p/2, polygon );
      } else {
         drawpoly( p/2, polygon );
      }
      laenge /= 3;
      t++;
      getch();
      if ( tolower(loeschen)=='j' && laenge>=1 )
         cleardevice( WHITE );
   }
   setcolor(getmaxcolor());
   outtextxy(100, maxy-30, getmaxx(), getmaxy(), "Fertig !");
   getch();
   closegraph();
   return 0;
}
