#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/*----------- simulation ---------------------------------------------------*/
void simulation(long sim_laeufe)
{
   long int  ein_prozent=sim_laeufe/100,
             ein_sechs=0, zwei_sechs=0,
             i, j;

   for (i=1 ; i<=sim_laeufe ; i++) {
      for (j=1 ; j<=4 ; j++)  /*-- 4 mal mit einem Wuerfel wuerfeln --*/
         if (rand()%6==5) {
            ein_sechs++;
            break;
         }
      for (j=1 ; j<=24 ; j++)  /*-- 24 mal mit zwei Wuerfel wuerfeln --*/
         if (rand()%6==5 && rand()%6==5) {
            zwei_sechs++;
            break;
         }
      if (i%ein_prozent==0)
         fprintf(stderr, "\r......%ld%% der Simulationen durchgefuehrt", 
                i*100/sim_laeufe);
   }

   /*------- Durch Simulationen erhaltene Ergebnisse ausgeben ---------------*/
   printf("\n\n\nDie durch Simulationen erhaltenen Wahrscheinlichkeiten sind:\n\n"
          "| Mind. eine Sechs in 4 Wuerfen | Mind. eine Doppelsechs in 24 Wuerfen |\n"
          "+-------------------------------+--------------------------------------+\n"
          "| %29.3f | %36.3f |\n",
          (float)ein_sechs/sim_laeufe, (float)zwei_sechs/sim_laeufe);
}

/*----------- main ---------------------------------------------------------*/
int  main(void)
{
   long int  sim_laeufe;
   
   srand(time(NULL));

   /*------- Ausgabe einer kurzen Erklaerung --------------------------------*/
   printf("Ein klassisches Wahrscheinlichkeitsproblem\n"
          "==========================================\n\n"
          "Der Spieler Antoine Gombaud Chevalier de Mre fragte eines Tages\n"
          "den franzoesischen Mathematiker und Philosophen Pascal, ob es\n"
          "wahrscheinlicher sei, mindestens eine 6 bei 4 Wuerfen mit einem\n"
          "Wuerfel oder mindestens eine Doppelsechs bei 24 Wuerfen mit 2 Wuerfeln\n"
          "zu erhalten.\n\n"
          "Dieses Programm beantwortet diese Frage, indem es diese beiden\n"
          "Wurfarten n mal simuliert.\n\n\n");

   /*------- Einlesen der Simulations-Anzahl --------------------------------*/
   printf("Wieviel Simulationen: ");
   scanf("%ld", &sim_laeufe);
   simulation(sim_laeufe);
   return 0;
}
