#include  <stdio.h>
#include  <graphics.h>
#include  <stdlib.h>
#include  <time.h>
#include  <math.h>

#define SW  0.0001

/*---------- globale Variablen ------------------------------------------*/
double  xfmin, xfmax, yfmin, yfmax, xfaktor, yfaktor, xbnull, ybnull, a, b;

/*------- simuliere_zeichnen ----------------------------------------------*/
void  simuliere_zeichnen(double x, double y)
{
   if (y>yfmax)
      yfmax = y;
   if (y<yfmin)
      yfmin = y;
   if (x>xfmax)
      xfmax = x;
   if (x<xfmin)
      xfmin = x;
}

/*------- wirklich_zeichnen ----------------------------------------------*/
void wirklich_zeichnen(double x, double y)
{
   putpixel( (int)((x-xfmin)*xfaktor), (int)((yfmax-y)*yfaktor), BLUE );
}

/*------- funktion -------------------------------------------------------*/
void funktion(void (*f)(double x, double y))
{
   double  x, y;
   double  PI = 4*atan(1);
 
   for (x=xfmin ; x<=xfmax ; x+=SW) {
      y = cos(4*PI*x)*exp(-x);
      (*f)(x, y);
   }
}

/*------- main -----------------------------------------------------------*/
int  main( int argc, char *argv[] )
{
    srand(time(NULL));

    /*------- Eingaben des Benutzers ---------------------------------------*/
    printf("Graphische Darstellung der Funktion\n"
           "                      -x\n"
           "   y = cos(4*pi*x) * e\n");
    printf("\n\nxmin? ");  scanf("%lf", &xfmin);
    printf("xmax? ");      scanf("%lf", &xfmax);

    /*------- Berechnen der maximalen und minimalen Funktionswerte ---------*/
    yfmin = yfmax = exp(xfmin);
    funktion(simuliere_zeichnen); /*******************/
    
    /*------- Graphik initialisieren ---------------------------------------*/
    initgraph( 640, 480 );

    /*------- Massstab-Faktoren berechnen ----------------------------------*/
    xfaktor = getmaxx() / (xfmax-xfmin);
    yfaktor = getmaxy() / (yfmax-yfmin);

    /*------- Ausgabe der Koordinaten-Achse --------------------------------*/
    xbnull = -xfmin * xfaktor;
    ybnull =  yfmax * yfaktor;
    line(0, (int)ybnull, (int)xbnull, (int)ybnull);
    line((int)xbnull, 0, (int)xbnull, (int)ybnull);
    line(getmaxx(), (int)ybnull, (int)xbnull, (int)ybnull);
    line((int)xbnull, getmaxy(), (int)xbnull, (int)ybnull);

    /*------- Ausgabe der Funktion -----------------------------------------*/
    funktion(wirklich_zeichnen); /*******************/

    getch();
    closegraph();
    return(0);
}
