#include  <stdio.h>
#include  <math.h>
#include  <graphics.h>

/*---------- Makros fuer die Symbole der Produktionsregeln ---------------*/
#define   F   f(t-1);                             /* F */
#define   M   phi=phi-delta;                      /* - */
#define   P   phi=phi+delta;                      /* + */

/*---------- Makros, die Zeichen-Regeln beschreiben ---------------------*/
#define ANFWINKEL     0   /* Winkel zum Zeichnen der ersten Gerade */
#define DREHWINKEL   60   /* Drehwinkel (Schrittweite) */
#define LFAKTOR      (1.0/3)     /* Verkleinerungsfaktor fuer Laenge bei Rekursion */
#define STARTX     (getmaxx()/2-STARTLAENGE/2)   /* x-Koordinate zu Beginn */
#define STARTY     (getmaxy()/2+STARTLAENGE/3)   /* y-Koordinate zu Beginn */
#define STARTLAENGE   getmaxy()*0.75  /* Ausgangslaenge fuer das Zeichnen */
#define REKTIEFE      7  /* Rekursionstiefe */

double  x, y, laenge, phi, delta;

void  f(int t);

/*---------- main -------------------------------------------------------*/
int  main(int argc, char *argv[] )
{
   const double  PI=4*atan(1);
   int           t, i;

   delta = (DREHWINKEL*PI)/180;  /*---- Umrechnen Winkel in Bogenmass */

   initgraph( 640, 480 );

   laenge = STARTLAENGE;
   for (t=1; t<=REKTIEFE; t++) {
      cleardevice( WHITE );
      phi = (ANFWINKEL*PI)/180;   /*---- Umrechnen Winkel in Bogenmass */
      x=STARTX;
      y=STARTY;
      moveto( (int)x, (int)y );
      for (i=1; i<=3; i++) {
         f(t);
         P  P
      }
      laenge *= LFAKTOR;
      getch();
   }
   closegraph();
   return(0);
}

/*---------- f ----------------------------------------------------------*/
void f(int t)
{
   if (t>1) {
      F  M  F  P  P  F  M  F
   } else {
      x += laenge*cos(-phi);
      y += laenge*sin(-phi);
      lineto( (int)x, (int)y );
   }
}
