#include  <stdio.h>
#include  <math.h>
#include  <graphics.h>

/*---------- Makros fuer die Symbole der Produktionsregeln ---------------*/
#define   F   f(t-1);            /* F */
#define   M   phi=phi-delta;     /* - */
#define   P   phi=phi+delta;     /* + */

/*---------- Makros, die Zeichen-Regeln beschreiben ---------------------*/
/*------------- muessen fuer neue Bilder enstprechend gesetzt werden ----*/
#define ANFWINKEL     0     /* Winkel zum Zeichnen der ersten Gerade */
#define DREHWINKEL   90     /* Drehwinkel (Schrittweite) */
#define LFAKTOR    0.25     /* Verkleinerungsfaktor fuer Laenge bei Rekursion */
#define STARTX     (getmaxx()-4*STARTLAENGE)/2   /* x-Koordinate zu Beginn */
#define STARTY     getmaxy()/2                   /* y-Koordinate zu Beginn */
#define STARTLAENGE   getmaxy()/4  /* Ausgangslaenge fuer das Zeichnen */
#define REKTIEFE      5  /* Rekursionstiefe */

double  x, y, laenge, phi, delta;

void  f(int t);

/*---------- main -------------------------------------------------------*/
int  main( int argc, char *argv[] )
{
   const double  PI=4*atan(1);
   int           t;

   delta = (DREHWINKEL*PI)/180;  /*---- Umrechnen Winkel in Bogenmass */

   initgraph( 640, 480 );

   laenge = STARTLAENGE;
   for (t=1; t<=REKTIEFE; t++) {
      cleardevice( LIGHTBLUE );
      phi = (ANFWINKEL*PI)/180;   /*---- Umrechnen Winkel in Bogenmass */
      x=STARTX;
      y=STARTY;
      moveto( (int)x, (int)y);
      f(t);
      laenge *= LFAKTOR;
      getch();
   }
   closegraph();
   return(0);
}

/*---------- f ----------------------------------------------------------*/
void f(int t)
{
   if (t>0) {
      F F  P F  M F  M F F  P F  P F  M
   } else {
      x += laenge*cos(-phi);
      y += laenge*sin(-phi);
      lineto( (int)x, (int)y );
   }
}
