#include  <stdio.h>
#include  <math.h>
#include  <graphics.h>

/*---------- Makros fuer die Symbole der Produktionsregeln ---------------*/
#define   F   f(t-1);                                           /* F */
#define   M   phi=phi-delta;                                    /* - */
#define   P   phi=phi+delta;                                    /* + */
#define   A_  altx=x; alty=y; altphi=phi;                       /* [ */
#define   _Z  x=altx,y=alty,moveto((int)x,(int)y); phi=altphi;  /* ] */

/*---------- Makros, die Zeichen-Regeln beschreiben ---------------------*/
#define ANFWINKEL      90   /* Winkel zum Zeichnen der ersten Gerade */
#define DREHWINKEL   22.5   /* Drehwinkel (Schrittweite) */
#define LFAKTOR    0.5     /* Verkleinerungsfaktor fuer Laenge bei Rekursion */
#define STARTX     getmaxx()/2   /* x-Koordinate zu Beginn */
#define STARTY     getmaxy()     /* y-Koordinate zu Beginn */
#define STARTLAENGE   getmaxy()/4  /* Ausgangslaenge fuer das Zeichnen */
#define REKTIEFE      6  /* Rekursionstiefe */

double  x, y, laenge, phi, delta;  /* Globale Variablen */

void  f(int t);

/*---------- main -------------------------------------------------------*/
int  main( int argc, char *argv[] )
{
   const double  PI=4*atan(1);
   int           t;

   delta = (DREHWINKEL*PI)/180;  /*---- Umrechnen Winkel in Bogenmass */

   initgraph( 640, 480 );

   laenge = STARTLAENGE;
   for (t=1; t<=REKTIEFE; t++) {
      cleardevice( LIGHTBLUE );
      phi = (ANFWINKEL*PI)/180;   /*---- Umrechnen Winkel in Bogenmass */
      x=STARTX;
      y=STARTY;
      moveto( (int)x, (int)y );
      f(t);
      laenge *= LFAKTOR;
      getch();
   }
   closegraph();
   return(0);
}

/*---------- f ----------------------------------------------------------*/
void f(int t)
{
   double  altx, alty, altphi;

   if (t>1) {
      F F   M   A_ M F P F P F _Z   P  A_ P F M F M F _Z
   } else {
      x += laenge*cos(-phi);
      y += laenge*sin(-phi);
      lineto( (int)x, (int)y );
   }
}
