#include <stdio.h>

void block_ausgabe( long int wert, char einer, char fuenfer, char zehner );

/*----------- main ----------------------------------------------------------*/
int  main(void)
{
   long int   zahl;
   int        i;

   printf("\n\nArabische Zahlen in Roemische Zahlen umwandeln\n"
          "==============================================\n\n\n");

   while (1) {
      do {
         printf("Gib eine positive Zahl ein (Abbruch mit 0): ");
         scanf("%ld", &zahl);
      } while (zahl<0);
      if (zahl==0)
         break;

      printf("        ....... %ld = ", zahl);

      for (i=1 ; i<=zahl/1000 ; i++) /*--- Ausgabe aller Tausender (M) ---*/
         printf("M");
              
      zahl %= 1000;     /*--- Ausgabe fuer Zahlenbereich 100..900 ---*/
      block_ausgabe(zahl/100, 'C', 'D', 'M'); 
               
      zahl %= 100;      /*--- Ausgabe fuer Zahlenbereich 10..90 ---*/
      block_ausgabe(zahl/10, 'X', 'L', 'C');
               
      zahl %= 10;       /*--- Ausgabe fuer Zahlenbereich 1..9 ---*/
      block_ausgabe(zahl, 'I', 'V', 'X');
      printf(" ........\n\n");
   }
   return(0);
}

/*----------- block_ausgabe -------------------------------------------------*
 *
 *  Diese Funktion gibt immer den entsprechenden Block einer Zahl aus.
 * wert      ist die auszugebende Zehnerpotenz
 * einer     enthaelt immer das entspr. roemische Zeichen der Zehnerpotenz
 *               I=1, X=10, C=100
 * fuenfer   enthaelt immer das entspr. roemische Zeichen von 5 * Zehnerpotenz
 *               V=5, L=50, D=500
 * zehner    enthaelt immer das entspr. roemische Zeichen der naechsten
 *           Zehnerpotenz, die groesser als der wert ist.
 *               X=10, C=100, M=1000
 */
void block_ausgabe( long int wert, char einer, char fuenfer, char zehner )
{
   long int  i;

   if (wert==9)
      printf("%c%c", einer, zehner);
   else if (wert>4) {
      printf("%c", fuenfer);
      for (i=wert ; i>=6 ; i--)
          printf("%c", einer);
   } else if (wert==4)
      printf("%c%c", einer, fuenfer);
   else
      for (i=wert ; i>=1 ; i--)
         printf("%c", einer);
}
