#include <stdio.h>

#define bool    unsigned char
#define TRUE    1
#define FALSE   0

/*--------------- add ------------------------------------------------------*/
void add(unsigned std1, unsigned min1, unsigned sek1,
         unsigned std2, unsigned min2, unsigned sek2)
{
   unsigned int zeit1, zeit2, sum;
   unsigned int std, min, sek, tag;
   
   zeit1 = std1*3600 + min1*60+ sek1;
   zeit2 = std2*3600 + min2*60+ sek2;
   
   if ( ( sum = zeit1 + zeit2 ) >= 86400 ) {
      tag  = 1;
      sum -= 86400;
   }

   std = sum / 3600;
   min = (sum % 3600) / 60;
   sek = (sum % 3600) % 60;

   printf("\n%02d:%02d:%02d + %02d:%02d:%02d",
          std1, min1, sek1, std2, min2, sek2);
   printf(" = %s%02d:%02d:%02d\n", tag > 0 ? "1 Tag " : "", std, min, sek );
}

/*--------------- sub ------------------------------------------------------*/
void sub(unsigned std1, unsigned min1, unsigned sek1,
         unsigned std2, unsigned min2, unsigned sek2)
{
   unsigned int zeit1, zeit2;
   unsigned int std, min, sek, negativ=FALSE;
   int          diff;
 
   zeit1 = std1*3600 + min1*60+ sek1;
   zeit2 = std2*3600 + min2*60+ sek2;
   
   if ( ( diff = zeit1 - zeit2 ) < 0 ) {
      diff = 86400 - zeit2 + zeit1;
      negativ = TRUE;
   }
   std = diff / 3600;
   min = (diff % 3600) / 60;
   sek = (diff % 3600) % 60;

   printf("\n%02d:%02d:%02d - %02d:%02d:%02d",
          std1, min1, sek1, std2, min2, sek2);
   printf(" = %s%02d:%02d:%02d\n", negativ ? "-" : "", std, min, sek );
}

/*--------------- main -----------------------------------------------------*/
int  main(void)
{
   unsigned int   std1=0, min1=0, sek1=0;      /* 1. Uhrzeit */
   unsigned int   std2=0, min2=0, sek2=0;      /* 2. Uhrzeit */
   unsigned char  op;        /* gewaehlte Operation */
   bool  fehler;             /* Eingabefehler */

   printf("Taschenrechner fuer Uhrzeiten\n");
   printf("==============================\n");

   do {
      printf("\nBitte Startzeit eingeben (hh:mm:ss): ");
      scanf("%d:%d:%d", &std1, &min1, &sek1);
   } while ((std1 > 24 ) || (min1 > 60) || (sek1 > 60));

   do {
      printf("Bitte 2. Zeit eingeben (hh:mm:ss): ");
      getchar();
      scanf("%d:%d:%d", &std2, &min2, &sek2);
   } while ((std2 > 24 ) || (min2 > 60) || (sek2 > 60));
   getchar();

   do {
      fehler = FALSE;   /* Default: kein Eingabefehler*/
      printf("Bitte Operation eingeben (+/-): ");
      scanf("%c", &op);
      switch (op) {
         case '+':
            add(std1, min1, sek1, std2, min2, sek2);
            break;
         case '-':
            sub(std1, min1, sek1, std2, min2, sek2);
            break;
         default:
            printf("Falsche Eingabe!!\n");
            fehler= TRUE;
            break;
      }
   } while(fehler == TRUE);
   return(0);
}
