#include  <stdio.h>
#include  "bildschi.h"
#include  "fehler.h"
#include  "turing.h"

/*------- Konstanten-Definitionen -----------------------------------------*/
#define  RECHTS   +1
#define  LINKS    -1
#define  NICHTS    0

/*------- Modulglobale Variablen (nur innerhalb dieses Moduls verfuegbar) ---*/
static int   zustand=0;        /*-- aktueller Zustand                     */
static char  eingabe_zeichen;  /*-- zuletzt gelesenes Zeichen             */
static int   alt_kopfpos=0;    /*-- Alte Position des Lese-/Schreibkopfes */
static int   neu_kopfpos=0;    /*-- Neue Position des Lese-/Schreibkopfes */

/*------------- regel ---------------------------------------------------*/
static int  regel(int ausgab_zeich, int richtung, int neu_zustand)
{
    int  rueckgabe;
    
    neu_kopfpos += richtung;
    rueckgabe = bildschirm_bewege_kopf(alt_kopfpos, neu_kopfpos, 
                                       ausgab_zeich, &eingabe_zeichen,
                                       zustand, neu_zustand);
    alt_kopfpos = neu_kopfpos;
    zustand = neu_zustand;
    return(rueckgabe);
}

/*------------- erlaubtes_zeichen ---------------------------------------*/
boolean  erlaubtes_zeichen(char zeichen)
{
   return (zeichen=='I' || zeichen=='#');
}

/*------------- turing_regeln -------------------------------------------*/
int  turing_regeln(void)
{
    switch (zustand) {
       case  0:
          zustand=1;
          return ( (einaus_init(&eingabe_zeichen)==TRUE) ? OK : FEHLER );

       case  1:
          if (eingabe_zeichen=='I')
             return (regel('#', RECHTS, 2));    /*  1I#R2 */
          else if (eingabe_zeichen=='#')
             return (regel('#', RECHTS, 1));    /*  1##R1 */
          else
             return(FEHLER);

       case  2:
          if (eingabe_zeichen=='I')
             return (regel('#', RECHTS, 1));    /*  2I#R1 */
          if (eingabe_zeichen=='#')
             return (regel('#', NICHTS, 3));    /*  2##N3 */
          else 
             return(FEHLER);

       case  3:
          return(FERTIG);

       default:
          fehler_meld(".....Unerlaubter Zustand %d in turing_regeln...", zustand);
          return(FEHLER);
    }
}
