/*---------------------------------------------------------------------------
 *  Nach dem d'Hondtschen Hchstzahlverfahren sollen N Sitze auf P Parteien
 *  nach der erreichten Stimmenzahl verteilt werden.
 *  Verfahren:
 *    Die Gesamtstimmenzahlen werden der Reihe nach durch 1, 2, 3, usw.
 *    dividiert und die N Sitze nach der Reihenfolge der ermittelten Quotienten
 *    den Parteien zugeteilt.
 *-------------------------------------------------------------------------*/
#include <stdio.h>
#include <ctype.h>

#define ELEM_ZAHL(array)  sizeof(array)/sizeof(array[0])

char *partei[]={
       "ZTU",
       "SPT",
       "FTB",
       "Greens",
       "Rebubliks"
};
float  stimmen[ELEM_ZAHL(partei)],
       geteilt_stimmen[ELEM_ZAHL(partei)],
       teiler[ELEM_ZAHL(partei)];

int    sitze[ELEM_ZAHL(partei)]={0};

int  main(void)
{
    int   partei_zahl=ELEM_ZAHL(partei),
          i,
          sitz_zahl,
          max,
          vergeben=0;
    char  zeich;
    float gesamt_stimmen=0;

    printf("\n\nSitzverteilung nach d'Hondt\n");
    printf("===========================\n\n");
    printf("Geben Sie die abgegebenen Stimmen pro Partei ein\n");
    for (i=0 ; i<partei_zahl ; i++) {
        printf("%s: ", partei[i]);
        scanf("%f", &stimmen[i]); getchar();
        geteilt_stimmen[i]=stimmen[i];
        teiler[i]=1;
        gesamt_stimmen+=stimmen[i];
    }
    printf("\nWieviele Sitze sind zu vergeben: ");
    scanf("%d", &sitz_zahl); getchar();

    printf("\nSoll jede einzelne Sitzzuteilung ausgegeben werden (j/n) ? ");
    zeich=tolower(getchar()); getchar();
    printf("\n");

    while (vergeben < sitz_zahl) {
       max=0;
       for (i=1 ; i<partei_zahl ; i++)
          if (geteilt_stimmen[i]>geteilt_stimmen[max])
              max=i;
       sitze[max]++;
       ++vergeben;
       if (zeich=='j')
          printf("\n...Sitz %d geht an: %s (%.0f)",
                  vergeben, partei[max], geteilt_stimmen[max]);
       geteilt_stimmen[max]=stimmen[max]/++teiler[max];
    }

    printf("\n\nSitzverteilung:\n\n");
    printf("%10s | %5s | %20s | %20s |\n",
           "Partei", "Sitze", "Prozent (Sitze)", "Prozent (Stimmen)");
    printf("-----------+-------+----------------------+----------------------|\n");
    for (i=0 ; i<partei_zahl ; i++)
        printf("%10s | %5d | %20.2f | %20.2f |\n", partei[i], sitze[i],
               (float)sitze[i]/(float)sitz_zahl*100,
               stimmen[i]/gesamt_stimmen*100);
    return(0);
}
