#include <stdio.h>

#define MAX_ZELLEN  10000
#define OFFEN       1
#define ZU          !OFFEN

int  main(void)
{
    int   i, j, x, z=0;
    unsigned char  zelle[MAX_ZELLEN+1];

    printf("Amnestie bei Dodon, dem Maerchenkoenig\n"
           "======================================\n\n"
           "Dodon, der Maerchenkoenig, nahm bei einem Feldzug x Feinde gefangen, die\n"
           "er in 100 Einzelzellen steckte. An seinem Geburtstag sollten einige\n"
           "freigelassen werden, und zwar nach einem ganz eigenartigen Verfahren\n"
           "(vom Hofmathematiker ausgedacht): Dieses Verfahren arbeitet mit\n"
           "mehreren Durchgaengen, wobei in jedem Durchgang fuer jede betroffene\n"
           "Zellentuer folgender Zustandswechsel durchgefuehrt wird:\n"
           "  - Ist entspr. Tuer zum Zeitpunkt offen, wird sie geschlossen bzw.\n"
           "  - Ist entspr. Tuer zum Zeitpunkt geschlossen, wird sie geoeffnet.\n"
           "Zunaechst sind alle Zellentueren geschlossen.\n"
           "1) Im 1.Durchgang ist dann jede Tuer von einem Zustandswechsel\n"
           "   betroffen, was heisst, da zu diesem Zeitpunkt alle Tueren\n"
           "   geschlossen sind, dass nun alle Tueren geoeffnet werden.\n"
           "2) Im 2.Durchgang ist dann nur jede zweite Tuer von einem\n"
           "   Zustandswechsel betroffen.\n"
           "3) Im 3.Durchgang ist dann nur jede dritte Tuer von einem\n"
           "   Zustandswechsel betroffen.\n"
           "Und so geht es im 4.ten, 5.ten, ... bis zum x.ten Durchgang weiter.\n\n"
           "Dieses Programm beantwortet nun die Frage, welche Zellentueren offen-\n"
           "standen, als der Geburtstag des Koenigs anbrach\n\n");

    do {    /*----- Anzahl der Gefangenen einlesen -------------------------*/
       printf("Wieviele Gefangene (mind. 1; max %d): ", MAX_ZELLEN);
       scanf("%d", &x);
    } while (x<1 || x>MAX_ZELLEN);

    for (i=1 ; i<=x ; i++)  /*----- Alle Zellentueren schliessen -----------*/
       zelle[i]=ZU;

    for (i=1 ; i<=x ; i++)  /*----- Durchgaenge des Oeffnens/Schliessen ----*/
       for (j=i ; j<=x ; j+=i)
          zelle[j]=!zelle[j];

    printf("\n\nDie Zellen mit folgenden Nummern sind danach geoeffnet:\n");
    for (i=1 ; i<=x ; i++)  /*----- Ausgabe der offenen Zellen -------------*/
       if (zelle[i]==OFFEN) {
          printf("%8d", i);
          if (++z%10 == 0)
             printf("\n");
       }
   printf("\n");
   return(0);
}
