#include  <stdio.h>
#include  <stdlib.h>
#include  <time.h>

#define  MIN   10
#define  MAX   50

void  ausgabe(char array[], int n, int von, int bis);
void  iterativ_spiegeln(char array[], int von, int bis);
void  rekursiv_spiegeln(char array[], int von, int bis, int aktuell);

int  main(void)
{
   char   array[MAX+1];
   int    i, groesse, von, bis;

   printf("\n\n\nSpiegelung eines (Teil-)Arrays\n"
          "==============================\n\n");
   srand(time(NULL));

   groesse = rand()%(MAX-MIN)+MIN;
   for (i=1; i<=groesse; i++)
      array[i] = 'a'+rand()%26;
   von = rand()%groesse+1;
   while ( (bis=rand()%groesse+1) < von)
      ;
   ausgabe(array, groesse, von, bis);

   printf("\nSpiegelung erfolgt von %d bis %d:\n", von, bis);
   iterativ_spiegeln(array, von, bis);   
   ausgabe(array, groesse, von, bis);
   rekursiv_spiegeln(array, von, bis, von);
   ausgabe(array, groesse, von, bis);
   return(0);
}

void  ausgabe(char array[], int n, int von, int bis)
{
   int i;

   printf("  |");   
   for (i=1; i<=n; i++) {
      if (i==von)
         printf(" ");
      printf("%c", array[i]);
      if (i==bis)
         printf(" ");
   }
   printf("|\n");
}

void  iterativ_spiegeln(char array[], int von, int bis)
{
   int   i;
   char  h;
   
   if (von < bis)
      for (i=von; i<=(von+bis)/2; i++) {
         h                  = array[i];
         array[i]           = array[bis-(i-von)];
         array[bis-(i-von)] = h;
      } 
}

void  rekursiv_spiegeln(char array[], int von, int bis, int aktuell)
{
   char  h;

   if (aktuell <= bis) {
      h = array[aktuell];
      rekursiv_spiegeln(array, von, bis, aktuell+1);
      array[bis-(aktuell-von)] = h;
   }   
}
