#include  <stdio.h>
#include  <stdlib.h>
#include  <time.h>

#define ARRAY_GROESSE  1000
#define ITERATIONEN    1000000L

/*--------- vergl --------------------------------------------------*/
int  vergl(const void *zahl1, const void *zahl2)
{
    if (*(float *)zahl1 > *(float*)zahl2)
       return(1);
    else if (*(float *)zahl1 < *(float*)zahl2)
       return(-1);
    else
       return(0);
}

/*--------- binsuch ------------------------------------------------*/
float *binsuch(float x, float *array, int n, long *zaehl)
{
   int lo=0, hi=n-1;

   while (lo <= hi) {
      int mid = (lo+hi)/2;
      (*zaehl)++;
      if (x < array[mid])       
         hi = mid-1;    
      else if (x > array[mid])  
         lo = mid+1;    
      else      
         return(array+mid);     
   }    
   return(NULL);    /* NULL-Zeiger zeigt an, dass nichts gefunden */
}

/*--------- main -----------------------------------------------------------*/
int  main(void)
{
   long     i, zaehl=0;
   float    fzahlen[ARRAY_GROESSE];
   clock_t  zeit1, zeit2;

   srand(time(NULL));

   for (i=0 ; i<ARRAY_GROESSE ; i++)
      fzahlen[i] = (rand()%500)/(float)(rand()%500+1);

   qsort(fzahlen,                       /* Startadr. des zu sortier. Arrays */
         sizeof(fzahlen)/sizeof(float), /* Anzahl der Elemente; hier 1001   */
         sizeof(float),                 /* Groesse eines Array-Elements     */
         vergl);                        /* Name der Vergleichsroutine       */

   zeit1 = clock();
   for (i=1 ; i<=ITERATIONEN; i++) {
      float z = fzahlen[rand()%ARRAY_GROESSE];
      binsuch(z, fzahlen, ARRAY_GROESSE, &zaehl);
   }
   zeit2 = clock();

   printf("--------------------------------------------------------\n");
   printf("Vergleiche insgesamt:      %ld\n", zaehl);
   printf("Vergleiche durchschnittl.: %.2f\n", (float)zaehl/ITERATIONEN);
   printf("Gebrauchte Zeit:           %.2f Sek.\n", 
          (float)(zeit2-zeit1) / CLOCKS_PER_SEC);
   printf("--------------------------------------------------------\n");
   return(0);
}
