#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <ctype.h>

#define   MAX_ZEICHEN      1000  /* Max. Laenge einer Zeile */
#define   BLOCK_GROESSE     100   /* Wuerde hier 1 angegeben, so wuerde auch
                                     das Array bei jeder neuen Zeile nur um
                                     ein Element vergroessert. Um das Programm
                                     schneller zu machen, wurde hier 100
                                     gewaehlt (bei Bedarf um 100 Elemente
                                     vergroessern                            */

int  main(int argc, char *argv[])
{
   char   **zeile = NULL, puffer[MAX_ZEICHEN], *progname = argv[0];
   long   zeilnr=0, max_zeilnr=0, i;
   int    zeich, rueckwaerts=0, numerieren=0, richtig=1;

   while (--argc>0 && (*++argv)[0]=='-')
       while ( (zeich = *++argv[0]) ) 
           switch (tolower(zeich))  {
              case 'r':   rueckwaerts=1;  break;
              case 'n':   numerieren=1;   break;
               default:   printf(".......Unerlaubte Option: `-%c'\n", zeich);
                          richtig = 0;
                          break;
           }
   if (!richtig) {
      printf("usage: %s [-r -n]\n", progname);
      return(1);
   }
   while (fgets(puffer, MAX_ZEICHEN, stdin) != NULL) {
      if (zeilnr >= max_zeilnr) {
         max_zeilnr += BLOCK_GROESSE;
         zeile = (char **)realloc(zeile, max_zeilnr*sizeof(char *));
         if (zeile == NULL) {
            printf("......Speicherplatzmangel\n");
            return(2);
         }
      }
      if ( (zeile[zeilnr] = (char *)malloc(strlen(puffer)+1)) == NULL) {
         printf("......Speicherplatzmangel\n");
         return(3);
      }
      strcpy(zeile[zeilnr], puffer);
      zeilnr++;
   }
   zeilnr--;
   if (rueckwaerts)
      for (i=zeilnr; i>=0; i--) {
         if (numerieren)
            printf("%6ld: ", i+1);
         printf("%s", zeile[i]);
      }
   else 
      for (i=0; i<=zeilnr; i++) {
         if (numerieren)
            printf("%6ld ", i+1);
         printf("%s", zeile[i]);
      }
   return(0);
}
