#include  <stdio.h>
#include  <string.h>
#include  <stdlib.h>

#define  BLOCK_GROESSE  100  /* Wuerde hier 1 angegeben, so wuerde auch das
                                Array bei jeder neuen Person nur um ein
                                Strukturelement vergroessert. Um das Programm
                                schneller zu machen, wurde hier 100 gewaehlt
                                (bei Bedarf um 100 Elemente vergroessern     */
struct  datum  {
    int   tag; 
    int   monat;
    int   jahr;
};
struct  person  {
    char           *name;
    char           *vorname;
    struct  datum  geb;
    struct  datum  anst;
};
struct person   **angest=NULL;  /* Dynamisches Array fuer Angestellten-Daten */

int   einlesen(void);
int   auswahl(void);
void  sortieren(int anzahl, int auswahl);
void  ausgeben(int anzahl);
int   vergl_name(const void *zgr1, const void *zgr2);
int   vergl_vorname(const void *zgr1, const void *zgr2);
int   vergl_geb(const void *zgr1, const void *zgr2);
int   vergl_anst(const void *zgr1, const void *zgr2);

/*----------------------------------------------------------------- main ----*/
int  main(void)
{
    int  wahl, anzahl;
    
    anzahl = einlesen();
    while ((wahl = auswahl()) != 0) {
       sortieren(anzahl, wahl);
       ausgeben(anzahl);
    }
    return(0);
}

/*------------------------------------------------------------- einlesen ----*/
int  einlesen(void)
{
    int  n=0, max_n=0;
    char string[100];

    while (1) {
       printf("\n----Eingabe der %d.Person----\n", n+1);
       printf("Name:                      ");
       fgets(string, 100, stdin);
       string[strlen(string)-1] = '\0'; /* \n am Ende entfernen */
       if (strlen(string) == 0)
          break;
       if (n >= max_n) {
          max_n += BLOCK_GROESSE;
          angest = (struct person **)realloc(angest, max_n*sizeof(struct person *));
          if (angest == NULL) {
             printf("......Speicherplatzmangel\n");
             exit(1);
          }
       }
       if ( (angest[n] = (struct person *)malloc(sizeof(struct person))) == NULL) {
          printf("......Speicherplatzmangel\n");
          exit(2);
       }
       if ( (angest[n]->name = (char *)malloc(strlen(string)+1)) == NULL) {
          printf("......Speicherplatzmangel\n");
          exit(3);
       }
       strcpy(angest[n]->name, string);
       printf("Vorname:                   ");
       fgets(string, 100, stdin);
       string[strlen(string)-1] = '\0'; /* \n am Ende entfernen */
       if ( (angest[n]->vorname = (char *)malloc(strlen(string)+1)) == NULL) {
          printf("......Speicherplatzmangel\n");
          exit(3);
       }
       strcpy(angest[n]->vorname, string);
       printf("Geburtsdatum (tt.mm.jjjj): ");
       scanf("%d.%d.%d", &angest[n]->geb.tag,
                         &angest[n]->geb.monat,
                         &angest[n]->geb.jahr);
       printf("Anstelldatum (tt.mm.jjjj): ");
       scanf("%d.%d.%d", &angest[n]->anst.tag,
                         &angest[n]->anst.monat,
                         &angest[n]->anst.jahr);
       getchar();
       n++;
    }
    return(n);
}

/*-------------------------------------------------------------- auswahl ----*/
int  auswahl(void)
{
    int  wahl;
    char string[100];

    printf("\n.....Weiter mit Return....\n");
    fgets(string, 100, stdin);
    do {
       printf("Verwaltung der Angestellten\n"
              "===========================\n\n"
              "  0    Ende\n"
              "  1    Sortieren nach Name\n"
              "  2    Sortieren nach Vorname\n"
              "  3    Sortieren nach Geburtsdatum\n"
              "  4    Sortieren nach Einstelldatum\n"
              " Ihre Wahl: ");
       scanf("%d", &wahl);
       getchar();
    } while (wahl < 0 || wahl > 4);
    return(wahl);
}

/*------------------------------------------------------------ sortieren ----*/
void  sortieren(int anzahl, int wahl)
{
    switch (wahl) {
        case 1:  qsort(angest, anzahl, sizeof(struct person *), &vergl_name);
                 break;
        case 2:  qsort(angest, anzahl, sizeof(struct person *), &vergl_vorname);
                 break;
        case 3:  qsort(angest, anzahl, sizeof(struct person *), &vergl_geb);
                 break;
        case 4:  qsort(angest, anzahl, sizeof(struct person *), &vergl_anst);
                 break;
        default: printf("...... Programminterner Fehler...\n");
                 break;
    }
}

/*------------------------------------------------------------- ausgeben ----*/
void  ausgeben(int anzahl)
{
    int  i;

    printf("     %-20s, %-20s, Geb.Datum,  Einst.Datum\n", "Name", "Vorname");
    printf("-------------------------------------------------------------------\n");
    for (i=0; i<anzahl; i++)
       printf("%3d. %-20s, %-20s, %02d.%02d.%04d, %02d.%02d.%04d\n",
              i+1, angest[i]->name, angest[i]->vorname, 
                   angest[i]->geb.tag, angest[i]->geb.monat, angest[i]->geb.jahr,
                   angest[i]->anst.tag, angest[i]->anst.monat, angest[i]->anst.jahr);
}

/*----------------------------------------------------------- vergl_name ----*/
int  vergl_name(const void *zgr1, const void *zgr2)
{
   struct person  **p1 = (struct person **)zgr1,
                  **p2 = (struct person **)zgr2;
   int    vergl=0;
   
   if      ( (vergl = strcmp( (*p1)->name, (*p2)->name) ) != 0 )       ;
   else if ( (vergl = strcmp( (*p1)->vorname, (*p2)->vorname) ) != 0 ) ;
   else if ( (vergl = vergl_geb(zgr1, zgr2)) != 0 )                    ;
   else if ( (vergl = vergl_anst(zgr1, zgr2)) != 0 )                   ;
   return( vergl );
}

/*-------------------------------------------------------- vergl_vorname ----*/
int  vergl_vorname(const void *zgr1, const void *zgr2)
{
   struct person  **p1 = (struct person **)zgr1,
                  **p2 = (struct person **)zgr2;
   int    vergl=0;
   
   if      ( (vergl = strcmp( (*p1)->vorname, (*p2)->vorname) ) != 0 ) ;
   else if ( (vergl = strcmp( (*p1)->name, (*p2)->name) ) != 0 )       ;
   else if ( (vergl = vergl_geb(zgr1, zgr2)) != 0 )                    ;
   else if ( (vergl = vergl_anst(zgr1, zgr2)) != 0 )                   ;
   return( vergl );
}

/*------------------------------------------------------------ vergl_geb ----*/
int  vergl_geb(const void *zgr1, const void *zgr2)
{
   struct person  **p1 = (struct person **)zgr1,
                  **p2 = (struct person **)zgr2;
   int    vergl=0;

   if      ( (vergl = (*p1)->geb.jahr - (*p2)->geb.jahr)  != 0)       ;
   else if ( (vergl = (*p1)->geb.monat- (*p2)->geb.monat) != 0)       ;
   else if ( (vergl = (*p1)->geb.tag  - (*p2)->geb.tag)   != 0)       ;
   else if ( (vergl = strcmp( (*p1)->name, (*p2)->name) ) != 0 )       ;
   else if ( (vergl = strcmp( (*p1)->vorname, (*p2)->vorname) ) != 0 ) ;
   return( vergl );
}

/*----------------------------------------------------------- vergl_anst ----*/
int  vergl_anst(const void *zgr1, const void *zgr2)
{
   struct person  **p1 = (struct person **)zgr1,
                  **p2 = (struct person **)zgr2;
   int    vergl=0;

   if      ( (vergl = (*p1)->anst.jahr - (*p2)->anst.jahr)  != 0)       ;
   else if ( (vergl = (*p1)->anst.monat- (*p2)->anst.monat) != 0)       ;
   else if ( (vergl = (*p1)->anst.tag  - (*p2)->anst.tag)   != 0)       ;
   else if ( (vergl = strcmp( (*p1)->name, (*p2)->name) ) != 0 )       ;
   else if ( (vergl = strcmp( (*p1)->vorname, (*p2)->vorname) ) != 0 ) ;
   return( vergl );
}
