#include  <stdio.h>
#include  <string.h>

#define   MAX    100

struct  datum  {
    int   tag; 
    int   monat;
    int   jahr;
};
struct  person  {
    char    name[20];
    char    vorname[20];
    struct  datum  geb;
    struct  datum  anst;
};
struct person   angest[MAX];  /* Array mit Daten der Angestellten */

int   einlesen(void);
int   auswahl(void);
void  sortieren(int anzahl, int auawahl);
void  ausgeben(int anzahl);
int   vergl_geb(int i, int j);
int   vergl_anst(int i, int j);
void  umspeicher(int i, int j);

/*----------------------------------------------------------------- main ----*/
int  main(void)
{
    int  wahl, anzahl;
    
    anzahl = einlesen();
    while ((wahl = auswahl()) != 0) {
       sortieren(anzahl, wahl);
       ausgeben(anzahl);
    }
    return(0);
}

/*------------------------------------------------------------- einlesen ----*/
int  einlesen(void)
{
    int  i=0;

    for (i=0; i<MAX; i++) {
       printf("\n----Eingabe der %d.Person----\n", i+1);
       printf("Name:                      ");
       fgets(angest[i].name, 20, stdin);
       angest[i].name[ strlen(angest[i].name)-1 ] = '\0'; /* \n am Ende entfernen */
       if (strlen(angest[i].name) == 0)
          break;
       printf("Vorname:                   ");
       fgets(angest[i].vorname, 20, stdin);
       angest[i].vorname[ strlen(angest[i].vorname)-1 ] = '\0';
       printf("Geburtsdatum (tt.mm.jjjj): ");
       scanf("%d.%d.%d", &angest[i].geb.tag,
                         &angest[i].geb.monat,
                         &angest[i].geb.jahr);
       printf("Anstelldatum (tt.mm.jjjj): ");
       scanf("%d.%d.%d", &angest[i].anst.tag,
                         &angest[i].anst.monat,
                         &angest[i].anst.jahr);
       getchar();
    }
    return(i);
}

/*-------------------------------------------------------------- auswahl ----*/
int  auswahl(void)
{
    int  wahl;
    char string[100];

    printf("\n.....Weiter mit Return....\n");
    fgets(string, 100, stdin);
    do {
       printf("Verwaltung der Angestellten\n"
              "===========================\n\n"
              "  0    Ende\n"
              "  1    Sortieren nach Name\n"
              "  2    Sortieren nach Vorname\n"
              "  3    Sortieren nach Geburtsdatum\n"
              "  4    Sortieren nach Einstelldatum\n"
              " Ihre Wahl: ");
       scanf("%d", &wahl);
       getchar();
    } while (wahl < 0 || wahl > 4);
    return(wahl);
}

/*------------------------------------------------------------ sortieren ----*/
void  sortieren(int anzahl, int wahl)
{
    int  i, j, name_vergl, vorname_vergl, geb_vergl, anst_vergl;
    
    for (i=0; i<anzahl-1; i++)   /*......  Bubble-Sort */
       for (j=i+1; j<anzahl; j++) {
          name_vergl    = strcmp(angest[i].name, angest[j].name);
          vorname_vergl = strcmp(angest[i].vorname, angest[j].vorname);
          geb_vergl     = vergl_geb(i, j);
          anst_vergl    = vergl_anst(i, j);
          switch (wahl) {
             case 1:
                if (name_vergl > 0                                       || 
                    (name_vergl==0 && vorname_vergl > 0)                 ||
                    (name_vergl==0 && vorname_vergl==0 && geb_vergl > 0)   )
                   umspeicher(i, j);
                break;
             case 2:
                if (vorname_vergl > 0                                    || 
                    (vorname_vergl==0 && name_vergl > 0)                 ||
                    (vorname_vergl==0 && name_vergl==0 && geb_vergl > 0)   )
                   umspeicher(i, j);
                break;
             case 3:
                if (geb_vergl > 0                                        ||
                    (geb_vergl==0 && name_vergl > 0)                     ||
                    (geb_vergl==0 && name_vergl==0 && vorname_vergl > 0)   )
                   umspeicher(i, j);
                break;
             case 4:
                if (anst_vergl > 0                                        ||
                    (anst_vergl==0 && name_vergl > 0)                     ||
                    (anst_vergl==0 && name_vergl==0 && vorname_vergl > 0)   )
                   umspeicher(i, j);
                break;
             default:
                printf("...... Programminterner Fehler...\n");
                break;
          }
       }
}

/*------------------------------------------------------------- ausgeben ----*/
void  ausgeben(int anzahl)
{
    int  i;

    printf("     %-20s, %-20s, Geb.Datum,  Einst.Datum\n", "Name", "Vorname");
    printf("-------------------------------------------------------------------\n");
    for (i=0; i<anzahl; i++)
       printf("%3d. %-20s, %-20s, %02d.%02d.%04d, %02d.%02d.%04d\n",
              i+1, angest[i].name, angest[i].vorname, 
                   angest[i].geb.tag, angest[i].geb.monat, angest[i].geb.jahr,
                   angest[i].anst.tag, angest[i].anst.monat, angest[i].anst.jahr);
}

/*------------------------------------------------------------ vergl_geb ----*/
int  vergl_geb(int i, int j)
{
   if      (angest[i].geb.jahr < angest[j].geb.jahr)   return(-1);
   else if (angest[i].geb.jahr > angest[j].geb.jahr)   return(1);
   else if (angest[i].geb.monat < angest[j].geb.monat) return(-1);
   else if (angest[i].geb.monat > angest[j].geb.monat) return(1);
   else if (angest[i].geb.tag < angest[j].geb.tag)     return(-1);
   else if (angest[i].geb.tag > angest[j].geb.tag)     return(1);
   return(0);
}

/*----------------------------------------------------------- vergl_anst ----*/
int  vergl_anst(int i, int j)
{
   if      (angest[i].anst.jahr < angest[j].anst.jahr)   return(-1);
   else if (angest[i].anst.jahr > angest[j].anst.jahr)   return(1);
   else if (angest[i].anst.monat < angest[j].anst.monat) return(-1);
   else if (angest[i].anst.monat > angest[j].anst.monat) return(1);
   else if (angest[i].anst.tag < angest[j].anst.tag)     return(-1);
   else if (angest[i].anst.tag > angest[j].anst.tag)     return(1);
   return(0);
}

/*----------------------------------------------------------- umspeicher ----*/
void  umspeicher(int i, int j)
{
    struct person  hilf;
    
    hilf      = angest[i];
    angest[i] = angest[j];
    angest[j] = hilf;
}
