#include  <stdio.h>
#include  <string.h>
#include  <ctype.h>
#include  <stdlib.h>

struct list_element  {
    char                 name[20];
    struct list_element  *naechst;
};
struct list_element  *kopf, *ende;

void  liste_initialisieren(void);
void  liste_ausgeben(void);
void  liste_einfuegen(void);
void  liste_loeschen(void);

/*------------------------------------------------------- main --------------*/
int  main(void)
{
    char   wahl;

    liste_initialisieren();

    while (1) {
       printf("\nNamensliste\n"
              "===========\n"
              "A   Ausgeben der Namensliste\n" 
              "N   Einfuegen eines neuen Namens\n" 
              "L   Loeschen eines Namens\n" 
              "E   Ende\n"
              "         Deine Wahl: ");
       wahl = tolower(getchar());
       getchar();
       if      (wahl == 'a')  liste_ausgeben();
       else if (wahl == 'n')  liste_einfuegen();
       else if (wahl == 'l')  liste_loeschen();
       else if (wahl == 'e')  break;
    }
    return(0);
}

/*--------------------------------------- liste_initialisieren --------------*/
void  liste_initialisieren(void)
{
                          /*.......... Anlegen eines Listen-Kopfes und -ende */
   kopf = (struct list_element*) malloc(sizeof(struct list_element));
   ende = (struct list_element*) malloc(sizeof(struct list_element));
   if (kopf == NULL || ende == NULL) {
      printf(".......Speicherplatzmangel\n");
      exit(1);
   }
   kopf->naechst = ende->naechst = ende;
}

/*--------------------------------------------- liste_ausgeben --------------*/
void  liste_ausgeben(void)
{
   struct list_element  *list_zgr;

   list_zgr = kopf->naechst;

   printf("....Liste..........\n");
   while (list_zgr != list_zgr->naechst) {
      printf("%s\n", list_zgr->name);
      list_zgr = list_zgr->naechst;
   }
   printf("....Listenende.....\n\n");
}

/*-------------------------------------------- liste_einfuegen --------------*/
void  liste_einfuegen(void)
{
   char                 string[20];
   struct list_element  *neu_element, *list_zgr;

   printf("\nGib den einzufuegenden Namen ein: ");
   fgets(string, 20, stdin);
   string[ strlen(string)-1 ] = '\0'; /* Entfernen von \n am Ende */
                             /*.......... Anlegen eines neuen Listenelements */
   neu_element = (struct list_element*) malloc(sizeof(struct list_element));
   if (neu_element == NULL) {
      printf(".......Speicherplatzmangel\n");
      exit(1);
   }
   strcpy(neu_element->name, string);

      /*........ Finden der Position, wo neuer Name in Liste einzufuegen ist */
   list_zgr = kopf;
   while (list_zgr->naechst != list_zgr->naechst->naechst) {
      if (strcmp(string, list_zgr->naechst->name) <= 0)
         break;
      list_zgr = list_zgr->naechst;
   }
                          /*........ Einfuegen des neuen Namens in die Liste */
   neu_element->naechst = list_zgr->naechst;
   list_zgr->naechst    = neu_element;
}

/*--------------------------------------------- liste_loeschen --------------*/
void  liste_loeschen(void)
{
   char                 string[20];
   struct list_element  *list_zgr, *loesch_zgr;

   printf("Gib den zu loeschenden Namen ein: ");
   fgets(string, 20, stdin);
   string[ strlen(string)-1 ] = '\0'; /* Entfernen von \n am Ende */
          /*........ Finden der Position des zu loeschenden Namens in Liste */
   list_zgr = kopf;
   while (list_zgr != list_zgr->naechst) {
      if (!strcmp(string, list_zgr->naechst->name))
         break;
      list_zgr = list_zgr->naechst;
   }
   if (list_zgr == list_zgr->naechst)
      printf("\n......Name `%s' nicht in Liste vorhanden....\n\n\n", string);
   else {
      loesch_zgr = list_zgr->naechst;
      list_zgr->naechst = list_zgr->naechst->naechst;
      free(loesch_zgr);
   }
}
