#include  <stdio.h>
#include  <string.h>
#include  <ctype.h>
#include  <stdlib.h>

struct list_element  {
    unsigned char        name[20];
    struct list_element  *nachfolger;
    struct list_element  *vorgaenger;
};
struct list_element  *kopf, *ende, *list_zgr;

void  liste_initialisieren(void);
void  liste_ausgeben(char *text);
void  liste_einfuegen(void);
void  liste_loeschen(void);
void  liste_suchen(char *name);

/*------------------------------------------------------- main --------------*/
int  main(void)
{
    char   wahl;

    liste_initialisieren();

    while (1) {
       printf("--------------------------------------------------------------\n"
              "N   Einfuegen eines neuen Namens\n" 
              "L   Loeschen eines Namens\n" 
              "E   Ende\n"
              "  Deine Wahl: ");
       wahl = tolower(getchar());
       getchar();
       if (wahl == 'n')       liste_einfuegen();
       else if (wahl == 'l')  liste_loeschen();
       else if (wahl == 'e')  break;
       printf("\n");
    }
    return(0);
}

/*--------------------------------------- liste_initialisieren --------------*/
void  liste_initialisieren(void)
{
                          /*.......... Anlegen eines Listen-Kopfes und -ende */
   kopf = (struct list_element*) malloc(sizeof(struct list_element));
   ende = (struct list_element*) malloc(sizeof(struct list_element));
   if (kopf == NULL || ende == NULL) {
      printf(".......Speicherplatzmangel\n");
      exit(1);
   }
   kopf->name[0] = 0;    /* In jedem Fall kleiner als jedes ASCII-Zeichen  */
   ende->name[0] = 255;  /* In jedem Fall groesser als jedes ASCII-Zeichen */
   ende->name[1] = 0;   
   kopf->vorgaenger = ende->vorgaenger = kopf;
   kopf->nachfolger = ende->nachfolger = ende;
   list_zgr = kopf;  /* Aktuellen Listenzeiger auf den Listen-Anfang stellen */
}

/*--------------------------------------------- liste_ausgeben --------------*/
void  liste_ausgeben(char *text)
{
   struct list_element  *l_zgr;

   printf("...................................................%s.......\n", text);
     
   l_zgr = kopf->nachfolger;                     /*....... Vorwaerts-Ausgabe */
   printf("Vorwaerts   : %sk", list_zgr==kopf ? "==> " : "    ");
   while (l_zgr != ende) {
      printf("%s%s", l_zgr==list_zgr ? " ==> " : " --> ", l_zgr->name);
      l_zgr = l_zgr->nachfolger;
   }
   printf("%se\n", list_zgr==ende ? " ==> " : " --> ");

   l_zgr = ende->vorgaenger;                     /*..... Rueckwaerts-Ausgabe */
   printf(" Rueckwaerts: %se", list_zgr==ende ? "==> " : "    ");
   while (l_zgr != kopf) {
      printf("%s%s", l_zgr==list_zgr ? " ==> " : " --> ", l_zgr->name);
      l_zgr = l_zgr->vorgaenger;
   }
   printf("%sk\n", list_zgr==kopf ? " ==> " : " --> ");
}

/*-------------------------------------------- liste_einfuegen --------------*/
void  liste_einfuegen(void)
{
   char                 string[20];
   struct list_element  *neu_element;

   printf("             Gib den einzufuegenden Namen ein: ");
   fgets(string, 20, stdin);
   string[ strlen(string)-1 ] = '\0'; /* \n am Ende entfernen */

   liste_ausgeben("Vor dem Einfuegen");
                             /*.......... Anlegen eines neuen Listenelements */
   neu_element = (struct list_element*) malloc(sizeof(struct list_element));
   if (neu_element == NULL) {
      printf(".......Speicherplatzmangel\n");
      exit(1);
   }
   strcpy(neu_element->name, string);

      /*.... Suchen des Knotens, nach dem neue Name in Liste einzufuegen ist */
   liste_suchen(string);

                          /*........ Einfuegen des neuen Namens in die Liste */
   neu_element->vorgaenger = list_zgr;
   neu_element->nachfolger = list_zgr->nachfolger;
   list_zgr->nachfolger->vorgaenger = neu_element;
   list_zgr->nachfolger             = neu_element;

   liste_ausgeben("Nach dem Einfuegen");
}

/*--------------------------------------------- liste_loeschen --------------*/
void  liste_loeschen(void)
{
   char                 string[20];
   struct list_element  *loesch_zgr;

   printf("             Gib den zu loeschenden Namen ein: ");
   fgets(string, 20, stdin);
   string[ strlen(string)-1 ] = '\0'; /* \n am Ende entfernen */

   liste_ausgeben("Vor dem Loeschen");

      /*.... Suchen des Knotens, nach dem sich zu loeschender Name befindet */
   liste_suchen(string);

   if (strcmp(string, list_zgr->nachfolger->name))
      printf("\n......Name `%s' nicht in Liste vorhanden....\n", string);
   else {
      loesch_zgr = list_zgr->nachfolger;
      list_zgr->nachfolger             = list_zgr->nachfolger->nachfolger;
      list_zgr->nachfolger->vorgaenger = list_zgr;
      free(loesch_zgr);
   }
 
   liste_ausgeben("Nach dem Loeschen");
}

/*----------------------------------------------- liste_suchen --------------*/
void  liste_suchen(char *name)
{
      /*.... Finden der Position, nach der Name einzufuegen bzw. zu loeschen */
   if (strcmp(name, kopf->nachfolger->name) <= 0)
      list_zgr = kopf;
   else if (strcmp(name, ende->vorgaenger->name) > 0)
      list_zgr = ende->vorgaenger;
   else {
      int  vergleich = strcmp(name, list_zgr->name);
      if (vergleich > 0)
         while (strcmp(name, list_zgr->nachfolger->name) > 0) {
            list_zgr = list_zgr->nachfolger;
            liste_ausgeben("Suchen");
         }            
      else if (vergleich < 0)
         while (strcmp(name, list_zgr->name) < 0) {
            list_zgr = list_zgr->vorgaenger;
            liste_ausgeben("Suchen");
         }            
      else
         while (strcmp(name, list_zgr->name) == 0) {
            list_zgr = list_zgr->vorgaenger;
            liste_ausgeben("Suchen");
         }
   }
}
