#include  <stdio.h>
#include  <ctype.h>

struct  symbole  {
    char  buchstab;
    char  *bild[7];
} symb_tabelle[] = {
    {'a',"   ___________",
         "  /Ausgabe:  /",
         " /          /",
         "/__________/"  },
    {'b'," ________",
         "(________)"   },
    {'e',"   ___________",
         "  /Eingabe:  /",
         " /          /",
         "/__________/"  },
    {'i',"  /\\",             /*  \\  entspricht dem Zeichen   \     */
         " /  \\",
         "/    \\",
         "\\    /",
         " \\  /",
         "  \\/"  },
    {'s'," ________",
         "(________)"  },
    {'t',"___________",
         "|         |",
         "|         |",
         "|_________|"  },
    {'u',"___________",
         "||       ||",
         "||       ||",
         "||_______||"  } 
   };

#define   ANZAHL   sizeof(symb_tabelle) / sizeof(struct symbole)

struct symbole  *binaer_suche(int wahl, struct symbole tabelle[], int laenge);
int             auswahl(void);

/*------------------------------------------------------------ main ------*/
int  main(void)
{
    struct  symbole   *zgr;
    int               i, wahl;

    while ( (wahl=auswahl()) != 'p') {
       if ((zgr=binaer_suche(wahl, symb_tabelle, ANZAHL)) != NULL) {
          i=0;
          while (zgr->bild[i])
             printf("%s\n", zgr->bild[i++]);
       }
       getchar();
   }
   return 0;
}

/*---------------------------------------------------- binaer_suche ------*/
struct symbole  *binaer_suche(int wahl, struct symbole tabelle[], int laenge)
{
    struct  symbole  *unten, *oben, *mitte;

    unten = &tabelle[0];
    oben  = &tabelle[laenge-1];
    while (unten<=oben) {
       mitte = unten + (oben-unten)/2;
       if (wahl < mitte->buchstab)
          oben = mitte-1;
       else if (wahl > mitte->buchstab)
          unten = mitte+1;
       else
          return(mitte);
    }
    return(NULL);
}

/*--------------------------------------------------------- auswahl ------*/
int  auswahl(void)
{
    printf("\n\n"
           "      A(usgabe)-Symbol\n"
           "      B(eginn)-Symbol\n"
           "      E(ingabe)-Symbol\n"
           "      I(f-Vergleich)-Symbol\n"
           "      S(top)-Symbol\n"
           "      T(aetigkeits)-Symbol\n"
           "      U(nterprogramm)-Symbol\n"
           "      P(rogrammende)\n\n"
           " Ihr Wahl: ");
    return(tolower(getchar()));
}
