#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <ctype.h>

struct eintrag {
    char           *wort;   /* zeigt auf das Wort                      */
    int             zaehl;  /* zaehlt die Vorkommen von wort           */
    struct eintrag *links;  /* linker Nachfolger-Knoten im Binaerbaum  */
    struct eintrag *rechts; /* rechter Nachfolger-Knoten im Binaerbaum */
};

struct eintrag  *binbaum(struct eintrag *zgr, char *wort);
void            druckebaum(struct eintrag *zgr);

/*--------------------------------------------------------- main -----------*/
int  main(void)
{
   struct eintrag  *wurzel=NULL;
   char            *wort, *trennzeichen = ".,;-:+*~'`=)(/{}[]&%$!?<>|\\#\"\t\n ",
                   zeile[500];
   int             i;
   
   printf("        Wortstatistik zu einem Text\n"
          "        ===========================\n\n");
   while (fgets(zeile, 500, stdin) != NULL) {
      wort = strtok(zeile, trennzeichen);
      while (wort != NULL) {
         for (i=0; i<strlen(wort); i++)
            wort[i] = tolower(wort[i]);
         wurzel = binbaum(wurzel, wort);
         wort   = strtok(NULL, trennzeichen);
      }
   }
   druckebaum(wurzel);

   return(0);
}

/*------------------------------------------------------ binbaum -----------*/
struct eintrag  *binbaum(struct eintrag *zgr, char *wort)
{
   int vergl;
      
   if (zgr == NULL) {  /* neues Wort */
      if ( (zgr = (struct eintrag *)malloc(sizeof(struct eintrag))) == NULL) {
         printf("........ Speicherplatzmangel\n");
         exit(1);
      }
      if ( (zgr->wort = (char *)malloc(strlen(wort)+1)) == NULL) {
         printf("........ Speicherplatzmangel\n");
         exit(1);
      }
      strcpy(zgr->wort, wort);
      zgr->zaehl = 1;
      zgr->links = zgr->rechts = NULL;
   } else if ( (vergl=strcmp(wort, zgr->wort)) == 0)
      zgr->zaehl++;   /* Wort kommt wiederholt vor */
   else if (vergl < 0)
      zgr->links = binbaum(zgr->links, wort);
   else   
      zgr->rechts = binbaum(zgr->rechts, wort);
   return(zgr);
}
           
/*--------------------------------------------------- druckebaum -----------*/
void  druckebaum(struct eintrag *zgr)
{
   if (zgr) {
      druckebaum(zgr->links);
      printf("%-20s : %5d\n", zgr->wort, zgr->zaehl++);
      druckebaum(zgr->rechts);
   }
}
