#include  <stdio.h>
#include  <stdlib.h>
#include  <time.h>

#define MAX_ZEICHEN  1024

void  oeffne_dateien(char *quelle, char *ziel, FILE **in, FILE **out);

/*---------------------------------------------------------- main ----------*/
int  main(int argc, char *argv[])
{
   int      zeich;
   FILE     *in, *out;
   int      n;
   clock_t  start, ende;
   unsigned char     puffer[MAX_ZEICHEN];

   if (argc != 3) {
      fprintf(stderr, ".....usage: %s quelldatei zieldatei\n", argv[0]);
      exit(1);
   }

   /*........................................... Zeichenweises Kopieren ...*/
   oeffne_dateien(argv[1], argv[2], &in, &out);
   start = clock();

   while ( (zeich=getc(in)) != EOF)
      if (putc(zeich, out) == EOF)
         fprintf(stderr, ".....Fehler bei putc");
   if (ferror(in))
      fprintf(stderr, ".....Fehler bei getc");

   ende = clock();
   fclose(in);
   fclose(out);
   fprintf(stderr, "Zeichenweises Kopieren: %.2f Sek\n",
                   (ende-start)/(float)CLOCKS_PER_SEC);

   /*........................................... Blockweise Kopieren ......*/
   oeffne_dateien(argv[1], argv[2], &in, &out);
   start = clock();

   while ( (n = fread(puffer, 1, MAX_ZEICHEN, in)) > 0)
      if (fwrite(puffer, 1, n, out) != n )
         fprintf(stderr, ".....Fehler bei fwrite\n");
   if (ferror(in))
      fprintf(stderr, ".....Fehler bei fread\n");

   ende = clock();
   fclose(in);
   fclose(out);
   fprintf(stderr, "Blockweises Kopieren  : %.2f Sek\n",
                   (ende-start)/(float)CLOCKS_PER_SEC);
   return(0);
}   

/*------------------------------------------------ oeffne_dateien ----------*/
void  oeffne_dateien(char *quelle, char *ziel, FILE **in, FILE **out)
{
   if ( (*in = fopen(quelle, "rb")) == NULL) {
      fprintf(stderr, ".....kann `%s' nicht zum Lesen ffnen\n", quelle);
      exit(2);
   }
   if ( (*out = fopen(ziel, "wb")) == NULL) {
      fprintf(stderr, ".....kann `%s' nicht zum Schreiben ffnen\n", ziel);
      exit(3);
   }
}
