#include  <stdio.h>
#include  <stdlib.h>
#include  <ctype.h>

#define BLOCK  100

int  main(int argc, char *argv[])
{
   FILE  *fz;
   int   n=1, zeich;
   long  *offset = NULL;  /*  Zeiger auf dynam. long-Array fr Zeilenoffsets  */
   long  von, bis, zeich_zahl=0, zeil_zahl=1;

   if (argc != 2) {     /*................. Falsche Anzahl Kommandoparameter  */
      fprintf(stderr, "usage: %s dateiname\n", argv[0]);
      exit(1);
   }
            /*.................... Speicher fr dynamisches Array allokieren  */
   if ((offset = (long*) realloc(offset, n*BLOCK*sizeof(long))) == NULL) {
      fprintf(stderr, "....Speicherplatzmangel\n");
      exit(2);
   }
            /*........................................... Datei binr ffnen  */
   if ((fz = fopen(argv[1], "rb")) == NULL) {
      fprintf(stderr, "....kann Datei `%s' nicht zum Lesen ffnen\n", argv[1]);
      exit(3);
   }

   offset[1] = 0;                          /*  Offset 1. Zeile ist 0          */
   while ( (zeich=fgetc(fz)) != EOF) {     /*  Datei lesen                    */
      if (zeich == '\n') {
         if (++zeil_zahl % BLOCK == 0) {     /*  Evtl. offset-Array verlaengern */
	    if ( (offset=(long*)realloc(offset, ++n*BLOCK*sizeof(long))) == NULL) {
               fprintf(stderr, "....Speicherplatzmangel\n");
               exit(2);
            }
         }
         offset[zeil_zahl] = ftell(fz);    /*  Offset neuer Zeile speichern   */
      }
   }
   zeil_zahl--; /* eins zu weit gezaehlt */
   
   zeich_zahl = ftell(fz);     /* Position nach dem Lesen (am Dateiende)      */
   printf("\n\n\n");
   if (zeich_zahl == 0) {       /* Datei ist leer */
      printf("....Datei ist leer");
      exit(4);
   } else
      printf("....Datei `%s' hat %ld Zeichen und %ld Zeile(n)...\n",
             argv[1], zeich_zahl, zeil_zahl);
 
   printf("\n\n");
   printf("Zeilen anzeigen? (j/n): ");
   if ( tolower(getchar()) == 'j') {
      while (1) {
         printf("\n");
         do {
            printf("Von Zeile (Ende mit 0):");
            scanf("%ld", &von);
         } while (von < 0);
         if (von==0)
            break;
         do {
            printf("Bis Zeile (max: %ld):", zeil_zahl);
            scanf("%ld", &bis);
         } while (bis < von || bis > zeil_zahl);
         fseek(fz, offset[von], SEEK_SET);  /* Position der 1. Ausgabezeile   */
         printf("%5ld  ", von);            /*  Zeilen 5-stellig numerieren   */
         while ( (zeich=fgetc(fz)) != EOF) {    /*  Ausgewhlte Zeilen lesen  */
            fputc(zeich, stdout);               /*  und ausgeben              */
            if (zeich == '\n') {
               if (von < bis)
                  printf("%5ld  ", ++von);
               else
                 break;
            }
         }
      }
   }
   fclose(fz);
   free(offset);
   return(0);
}
