#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <errno.h>
#include  <stdarg.h>
#include  "fehler.h"

#define  MAX_ZEICHEN   4096    /*--- Maximale Pufferlaenge */

/*------------------------ Lokale Routinen zur Abarbeitung der Argumentliste -*/
static void  fehl_meldung(int sys_meld, const char *fmt, va_list az)
{
   int  fehler_nr = errno;
   char puffer[MAX_ZEICHEN];
   
   vsprintf(puffer, fmt, az);
   if (sys_meld)
      sprintf(puffer+strlen(puffer), ": %s ", strerror(fehler_nr));
   fflush(stdout);   /* fuer Fall, dass stdout und stderr gleich sind */
   fprintf(stderr, "%s\n", puffer);
   fflush(NULL);  /* alle Ausgabepuffer flushen */
   return;
}

/*------------------------------------------ Global aufrufbare Fehlerroutine -*/
void  fehler_meld(int kennung, const char *fmt, ...)
{
   va_list     az;
   
   va_start(az, fmt);
   switch (kennung) {
      case WARNUNG:
      case FATAL:
              fehl_meldung(0, fmt, az);
              break;
      case WARNUNG_SYS:
      case FATAL_SYS:
              fehl_meldung(1, fmt, az);
              break;
       default:
              fehl_meldung(1, "Falscher Aufruf von fehler_meld...", az);
              exit(2);
   }
   va_end(az);

   if (kennung==WARNUNG || kennung==WARNUNG_SYS)
      return;
   exit(1);
}
