#include   <stdio.h>
#include   <stdlib.h>
#include   <ctype.h> 

static void hex_druck(FILE *fz, char *s);

/*---------------------------------------------------------- main --------*/
int  main( int argc, char *argv[] )
{
   FILE      *fz;
   int       i;

   if (argc < 2) {
      fprintf(stderr, "usage: %s datei1 .....", argv[0]);
      exit(1);
   }
   for (i=1; i<argc; i++) {
      if ((fz=fopen(argv[i],"rb")) == NULL)
         fprintf(stderr, "....kann Datei `%s' nicht eroeffnen\n", argv[i]);
      else {
         hex_druck(fz, argv[i]);
         fclose(fz);
      }
   }
   return(0);
}

/*----------------------------------------------------- hex_druck --------*/
static void hex_druck( FILE *fz, char *s )
{
    unsigned char  puffer[16];
    int            gelesen, i;
    long           gesamt=0;
    
    printf("----%s----\n", s);
    
    while ( (gelesen=fread(puffer, 1, 16, fz)) > 0) {
        printf("  %06lx ", gesamt);

        /*------- Ausgabe des Hexa-Musters */
        for (i=0 ; i<16 ; i++) {
           if (i < gelesen) {
              printf(" %02x", puffer[i]);
              if (iscntrl(puffer[i])) /* Falls puffer[i] ein Steuerzeichen */
                  puffer[i] = '.';    /* -> dann wird es mit . dargestellt */
           } else {
              fputs("   ",stdout);
              puffer[i] = ' ';
           }
           if (i==7)   /*--- Trennzeichen nach 8 Hexa-Bytemustern ausgeben */
              putchar(' ');
        }
       
        /*------- Ausgabe des zum Hexa-Muster gehoerigen Texts */
        printf(" |%16.16s|\n", puffer);
        gesamt += gelesen;
    }
}
