#include  <stdio.h>
#include  <stdlib.h>
#include  <sys/types.h>
#include  <sys/stat.h>
#include  <fcntl.h>
#include  <unistd.h>

#define  fehler_meld(a,b,nr)    { fprintf(stderr, a, b);    exit(nr); }
#define  fehler_meld2(a,b,c,nr) { fprintf(stderr, a, b, c); exit(nr); }

int  main(int argc, char *argv[])
{
   int       fd1, fd2,
             gelesen1, gelesen2;
   char      puffer1[2], puffer2[2];
   size_t    i=1;

   /*---- Ueberpruefen der Argumentzahl -------------------------------------*/
   if (argc != 3)
      fehler_meld("usage: %s datei1 datei2\n", argv[0], 2);
   
   /*---- Die beiden auf Kommandozeile angegeb. Dateien eroeffnen -----------*/
   if ( (fd1 = open(argv[1], O_RDONLY)) == -1)
      fehler_meld("....kann `%s' nicht zum Lesen oeffnen\n", argv[1], 3);
   if ( (fd2 = open(argv[2], O_RDONLY)) == -1)
      fehler_meld("....kann `%s' nicht zum Lesen oeffnen\n", argv[2], 4);

   /*---- Bytes in den beiden Dateien nacheinander ueberpruefen -------------*/
   while (1) {
      if ( (gelesen1 = read(fd1, puffer1, 1)) == -1)
         fehler_meld2("....Fehler beim Lesen aus `%s' (Bytenr %d)\n", argv[1], i, 5);
      if ( (gelesen2 = read(fd2, puffer2, 1)) == -1)
         fehler_meld2("....Fehler beim Lesen aus `%s' (Bytenr %d)\n", argv[2], i, 6);
      
      if (gelesen1==0 && gelesen2==0) { /*--- Dateiende in beiden erreicht ---*/
         fprintf(stderr, "%s und %s sind identisch\n", argv[1], argv[2]);
         return(0);
      } else if (gelesen1==0) {
         fprintf(stderr, "%s ist kleiner als %s (bis dorthin identisch)\n",
                         argv[1], argv[2]);
         exit(1);
      } else if (gelesen2==0) {
         fprintf(stderr, "%s ist groesser als %s (bis dorthin identisch)\n",
                         argv[1], argv[2]);
         exit(1);
      } else {
         if (puffer1[0] != puffer2[0]) {
            fprintf(stderr, "%d. Bytenr: (%s:0x%02x) <> (%s:0x%02x)\n",
                            i, argv[1], puffer1[0], argv[2], puffer2[0]);
            exit(1);
         } else 
            i++; 
      }
   } 
}
