#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <time.h>
#include <math.h>
#include <unistd.h>

clock_t   start, ende, differenz, record=1000000;
/*-------- Signal-Handler-Routinen ----------------------------------*/
void  strgbackslash_faenger(int sig)
{
    signal(SIGQUIT, SIG_IGN);
    printf("......Die schnellste STRG-C Tastenfolge dauerte %7.3f\n",
           record/(double)CLOCKS_PER_SEC);
    exit(0);
}

void  strgc_faenger(int sig)
{
      /* Fuer die Dauer dieser Funktionsausfhrung muessen weitere  */
      /* SIGINT-Signale ignoriert werden.                           */
    signal(SIGINT, SIG_IGN);

         /* Gebrauchte Zeit berechnen und ausgeben */
    ende=clock();
    differenz=ende-start;
    printf("Gebrauchte Zeit:  %10.3f Sek\n", differenz/(double)CLOCKS_PER_SEC);
    if (differenz<record) {
       record=differenz;
       printf("...........Neuer Rekord %10.3f Sek\n", record/(double)CLOCKS_PER_SEC);
    }
    sleep(rand()%2+1);
    printf("\nDruecke so schnell wie moeglich STRG-C.......\n");
    start=clock();

      /* Signal-Handler crtlc_faenger wieder fr SIGINT installieren */
    signal(SIGINT, SIG_IGN);
    if (signal(SIGINT, strgc_faenger) == SIG_ERR) {
        printf("Signal-Handler 'strgc_faenger' konnte "
               "nicht installiert werden\n");
        exit(1);
    }
}

/*-------- main -----------------------------------------------------*/
int  main(void)
{
       /* Startwert fr Pseude-Zufallszahlen erzeugen und   */
       /* Signal Handler installieren                       */
    srand( time(NULL) );
    if (signal(SIGQUIT, strgbackslash_faenger) == SIG_ERR) {
        printf("Signal-Handler 'strgbackslash_faenger' konnte "
               "nicht installiert werden\n");
        exit(1);
    }
    signal(SIGINT, SIG_IGN);
    sleep(rand()%2+1);
    printf("\nDruecke so schnell wie moeglich STRG-C.......\n");
    if (signal(SIGINT, strgc_faenger) == SIG_ERR) {
        printf("Signal-Handler 'strgc_faenger' konnte "
               "nicht installiert werden\n");
        exit(1);
    }
    start=clock();
    while (1)
       ;
    return 0;
}
