#include  <stdio.h>
#include  <stdlib.h>
#include  <setjmp.h>

int             global_var = 100;
static int      static_global_var = 100;
volatile int    volatile_global_var = 100;

static jmp_buf  schnapp;

void weit_sprung(void);

int main(void)
{
   int             lokal_var = 100;
   static int      static_lokal_var = 100;
   volatile int    volatile_lokal_var = 100;
   register int    register_lokal_var = 100;

   if (setjmp(schnapp) != 0) {
      printf("-----------------------------------------------------------\n");
      printf("   Nach 2.Rueckkehr von setjmp\n"
             "-----------------------------------------------------------\n"
             "lokal_var = %d\nstatic_lokal_var = %d\n"
             "volatile_lokal_var = %d\nregister_lokal_var = %d\n",
             lokal_var, static_lokal_var, volatile_lokal_var, register_lokal_var);
      printf("-------------------------\n");
      printf("global_var = %d\nstatic_global_var = %d\n"
             "volatile_global_var = %d\n",
             global_var, static_global_var, volatile_global_var);
      exit(0);   /* Programm wird hier verlassen */
   }

   printf("-----------------------------------------------------------\n");
   printf("   Nach 1.Rueckehr von setjmp\n"
          "-----------------------------------------------------------\n"
          "lokal_var = %d\nstatic_lokal_var = %d\n"
          "volatile_lokal_var = %d\nregister_lokal_var = %d\n",
          lokal_var, static_lokal_var, volatile_lokal_var, register_lokal_var);
   printf("-------------------------\n");
   printf("global_var = %d\nstatic_global_var = %d\n"
          "volatile_global_var = %d\n\n",
          global_var, static_global_var, volatile_global_var);

   /*----- Veraendern der lokalen und globalen Variablen ---*/
   lokal_var = -11111;
   static_lokal_var = -11111;
   volatile_lokal_var = -11111;
   register_lokal_var = -11111;
   global_var = -11111;
   static_global_var = -11111;
   volatile_global_var = -11111;

   weit_sprung();
                 
   printf("Ende\n"); /* Dieser Code wird nie erreicht werden */

}

void weit_sprung(void)
{
    longjmp(schnapp, 1);

    printf("Ende: weit_sprung\n"); /* Dieser Code wird nie erreicht werden */
}
