#include <stdio.h>
#include <ctype.h>

#define ZAHL   256
#define PLUS   257  /* + */
#define MINUS  258  /* - */
#define MULT   259  /* * */
#define DIV    260  /* / */
#define AUF    261  /* ( */
#define ZU     262  /* ) */

#define NICHTS     263
#define ZEILENENDE 264
#define FERTIG     265

int tokenwert = NICHTS; /* Programmglobale Variable, welcher im Falle      */
                        /* einer Zahl der Zahlenwert zugewiesen wird.      */
static char     zeich;

int lexan(void);    /* Lexikalische Analyse */
int ausdruck(int *token);  /* Abarbeitung eines Ausdrucks */
int term(int *token);      /*      "        "   Terms     */
int factor(int *token);    /*      "        "   Faktors   */
                 
int main(void) {
    int  token, ergeb;

    while ((token=lexan()) != FERTIG) {
        ergeb = ausdruck(&token);
        fprintf(stderr, ".... = %d\n", ergeb);
    }
    return 0;
}

int lexan( void ) {  /* Lexikalische Analyse */
   while (1) {
      zeich = getchar();
      if (zeich == ' ' || zeich == '\t') /* Leer- und Tabzeichen ueberlesen*/
          ;
      else if (zeich == '\n') {
         return(ZEILENENDE);
      } else if (isdigit(zeich)) {
         ungetc(zeich, stdin);  /* Zuviel gelesenes Zeichen zurueck */
                                /* in den Eingabepuffer             */
         scanf("%d", &tokenwert);
         return(ZAHL);
      } else if (zeich == EOF) {
         return(FERTIG);
      } else {
          switch (zeich) {
             case '+': return(PLUS);
             case '-': return(MINUS);
             case '*': return(MULT);
             case '/': return(DIV);
             case '(': return(AUF);
             case ')': return(ZU);
             default : return( NICHTS );
         }
      }
   }
}

int ausdruck( int *token ) {
   int ergeb = term(token);

   while (1) {
      switch(*token) {
         case PLUS : *token=lexan(); ergeb += term(token); break;
         case MINUS: *token=lexan(); ergeb -= term(token); break;
         default   : return(ergeb);
      }
   }
}

int term( int *token ) {
   int erg = factor(token);

   while (1) {
      switch (*token) {
         case MULT: *token=lexan(); erg *= factor(token); break;
         case DIV : *token=lexan(); erg /= factor(token); break;
         default  : return(erg);
      }
   }
}

int factor( int *token ) {
   int erg;

   switch (*token) {
      case ZAHL : erg = tokenwert; *token=lexan(); return(erg);
      case MINUS: switch (*token=lexan()) {
                     case ZAHL : erg = tokenwert; *token=lexan(); return(-erg);
                     default   : return(NICHTS);
                  }
      case AUF  : *token=lexan(); erg=ausdruck(token);
                  *token=lexan();
                  return(erg);
      default   : return(NICHTS);
   }
}
