#include <stdio.h>
#include <math.h>
#include <fenv.h>

#pragma FENV_ACCESS ON

void invalid(void)  { printf("FE_INVALID gesetzt\n"); }
void overflow(void) { printf("FE_OVERFLOW gesetzt\n"); }
void divbyzero(void) { printf("FE_DIVBYZERO gesetzt\n"); }

void func(void)
{
   int set_excepts = fetestexcept(FE_INVALID | FE_OVERFLOW | FE_DIVBYZERO);

   if (set_excepts & FE_INVALID) invalid();
   if (set_excepts & FE_OVERFLOW) overflow();
   if (set_excepts & FE_DIVBYZERO) divbyzero();
   printf("\n");
}

int main(void)
{
   fexcept_t akt;
   double    x;

   fesetexceptflag( &akt, FE_INVALID);
   func();
   feraiseexcept(FE_DIVBYZERO);
   func();

   x = sqrt(.5);
   printf("Voreingestellter Rundungsmodus:\n");
   printf("sqrt(.5) = 0x%08x 0x%08x = %16.15e\n",
          ((int *) &x)[0], ((int *) &x)[1], x);

   fesetround( FE_TOWARDZERO );
   x = sqrt(.5);
   printf("Rundungsmodus = FE_TOWARDZERO:\n");
   printf("sqrt(.5) = 0x%08x 0x%08x = %16.15e\n",
          ((int *) &x)[0], ((int *) &x)[1], x);

   fesetround( FE_TONEAREST );
   x = sqrt(.5);
   printf("Rundungsmodus = FE_TONEAREST:\n");
   printf("sqrt(.5) = 0x%08x 0x%08x = %16.15e\n",
          ((int *) &x)[0], ((int *) &x)[1], x);
   return 0;
}
