#include <stdio.h>
#include <stdlib.h>
#include <locale.h>

const char *locale[] = {
   "C", "POSIX", "de_CH", "de_DE", "de_DE@euro", "en_US", "danish", "deutsch",
   "dutch", "en_AU", "en_CA", "en_GB", "en_NZ",
   "fi_FI@euro", "finnish", "fr_BE", "fr_BE@euro", "fr_CA", "fr_CH", "fr_FR",
   "fr_FR@euro", "franais", "french", "german",
   "it_CH", "it_IT", "it_IT@euro", "italian", "japanese", "russian",
   "spanish", "swedish", "turkish"
};

const int anzahl  = sizeof(locale) / sizeof(locale[0]);

int main(void)
{
   struct lconv *lptr;

   int tausend = 27;
   int rest = 234;
   int nachkomma = 56;
   int i;

   for (i=0; i<6; i++) {
      setenv("LC_MONETARY", locale[i], 1);
      setlocale(LC_ALL, "");
      lptr = localeconv();
      printf("%10s: %s%d%c%d%c%d\n",
             locale[i], lptr->int_curr_symbol,
             tausend, lptr->mon_thousands_sep[0], rest,
             lptr->mon_decimal_point[0], nachkomma);
   }
   printf("--------------------------------------------------------------\n");
   for (i=0; i<anzahl; i++) {
      setenv("LC_MONETARY", locale[i], 1);
      setenv("LC_NUMERIC", locale[i], 1);
      setlocale(LC_ALL, "");
      lptr = localeconv();
      printf("| %-10s | %5s | %5s | %5s | %5s | %5s | %5s |\n",
             locale[i],
             lptr->decimal_point,     lptr->thousands_sep,
             lptr->int_curr_symbol,   lptr->currency_symbol,
             lptr->mon_decimal_point, lptr->mon_thousands_sep);
   }
   printf("--------------------------------------------------------------\n");
   system( "locale" ); /* Aufrufen des Linux-/Unix-Kommandos locale
                          zum Ausgeben der Locale-Environment-Variablen */
   return 0;
}
